/*
 * AppletMathGraph32.java
 *
 * Created on 26 juillet 2004, 14:30
 */

/**
 *
 * @author  Yves
 * @version 
 */
// Cette nouvelle version utilise JApplet et non Applet
//import java.applet.Applet;
package Applet;

  
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;

import org.scilab.forge.jlatexmath.TeXFormula;

import dialogs.*;

import entreesSorties.*;

import objets.*;

import outils.*;

import types.*;


@SuppressWarnings("serial")
public class AppletMathGraph32 extends JApplet implements MouseListener, MouseMotionListener, KeyListener,
    ActionListener, Runnable {
  // Variable de classe servant  connatre le nombre d'instances de l'applet
  private static int nbInstances;
  private static AppletManager appletManager;
  // Dialogue servant  l'historique. Sera affich par l'outil outilHistorique
  public HistoriqueDlg historiqueDlg;
  // Variable servant  savoir si le dialogue d'historique est en cours d'utilisation
  public boolean historiqueEnCours = false;
  // Pour les figures de construction, une variable boolean qui contiendra true
  // si les objets dsigns avec l'outil de validation outilPrpoSol sont bons
  public boolean constructionExacte;
  // Pour la version permettant des constructions, utilisation d'un gestionnaire
  // d'dition permettant d'annuler-refaire
  public GestionnaireEdition gestionnaire = new GestionnaireEdition(this);
  // A partir de la version 2.0, l'applet maintient un objet du type CPointBase
  // qui est charg de suivre les mouvements de la souris pour les aides visuelles ?
  // la cration d'objet
  public CPointBase pointSouris;
  // Les outils de pointage
  public OutilPointageCapt outilPointageCapture = new OutilPointageCapt(this);
  public OutilPointageClic outilPointageClic = new OutilPointageClic(this);
  public OutilPointageCre outilPointageCre = new OutilPointageCre(this);
  public OutilPointageSup outilPointageSup = new OutilPointageSup(this);
  public OutilPointageRapporteur outilPointageRapporteur = new OutilPointageRapporteur(this);
  public OutilPointageObjetClignotant outilPointageObjetClignotant =
          new OutilPointageObjetClignotant(this);
  public OutilPointagePropSol outilPointagePropSol = new OutilPointagePropSol(this);
  public OutilPointagePourNommer outilPointagePourNommer = new OutilPointagePourNommer(this);
  public OutilPointageHistorique outilPointageHistorique = new OutilPointageHistorique(this);
  // Pointeur sur l'outil de pointage actif qui est l'outil de capture au d?part
  public OutilPointage outilPointageActif = outilPointageCapture;
  // Pointeur sur l'outil de cration ou modification de la figure actif
  // Sera null si on est en mode capture d'objet.
  public Outil outilActif = null;
  // Un JColorChooser qui servira  choisir la couleur active. Il appartient  l'applet
  // car il mmorise les couleurs utilises
  JColorChooser colorChooser;
  // Le nombre de boutons  partir duquel on passe  3 colonnes d'icnes
  private static int nbBoutonsMiniPour3Col = 16;
  // Les boutons de la barre d'outils
  JMtgButton buttonCreerCalcul;
  JMtgButton buttonAnnuler;
  JMtgButton buttonRefaire;
  JMtgButton buttonCapt;
  JMtgButton buttonPtLib;
  JMtgButton buttonMil;
  JMtgButton buttonSeg;
  JMtgButton buttonDteAB;
  JMtgButton buttonDtePer;
  JMtgButton buttonDtePar;
  JMtgButton buttonDteBis;
  JMtgButton buttonDteMed;
  JMtgButton buttonDemiDt;
  JMtgButton buttonCerOA;
  JMtgButton buttonCerOR;
  JMtgButton buttonInt;
  JMtgButton buttonRapp;
  JMtgButton buttonTrans;
  JMtgButton buttonSymAxiale;
  JMtgButton buttonSymCentrale;
  JMtgButton buttonRot;
  JMtgButton buttonSup;
  JMtgButton buttonPtLie;
  JMtgButton buttonPropSol;
  JMtgButton buttonPtParAbs;
  JMtgButton buttonHom;
  JMtgButton buttonMesLong;
  JMtgButton buttonMesAngNor;
  JMtgButton buttonMesAngOr;
  JMtgButton buttonMesAbs;
  JMtgButton buttonHistorique;
  JMtgButton buttonNommer;
  JMtgColorButton colorButton;
  // Un groupe de boutons englobant tous ces boutons
  ButtonGroup btngroup;
  // Une zne de texte de deux lignes en bas de la fentre pour les indications
  JTextArea indicationArea = new JTextArea(1, 60);
  // Une zne d'une ligne informant sur la fonction de chaque outil
  JTextArea informationArea = new JTextArea(1, 60);
  
  // Les trois barres devant contenir les icnes. Il n'y en aura trois que s'il y a
  // beaucoup d'icones
  JToolBar bar1 = new JToolBar(JToolBar.VERTICAL);
  JToolBar bar2 = new JToolBar(JToolBar.VERTICAL);
  JToolBar bar3 = new JToolBar(JToolBar.VERTICAL);
  
  public JPanel bar4 = new JPanel();
  
  // Les panneaux contenant lers composants et la figure
  JPanel panePrincipal = new JPanel(); // Le panneau principal.
  JPanel paneLeftHigh = new JPanel();
  JPanel paneLeftLow = new JPanel();
  JPanel paneLeft = new JPanel();
  JPanel paneSouth = new JPanel();
  public MtgPaneFigure paneFigure = new MtgPaneFigure(this);
  int decalageBordGauche = 0; // Dcalage de la fentre contenant la figure par rapport
    // au bord gauche de la fentre
  int decalageBordBas = 0;
  // Outils de cration et modification
  OutilAnnuler outilAnnuler = new OutilAnnuler(this);
  OutilRefaire outilRefaire = new OutilRefaire(this);
  OutilCapture outilCapture = new OutilCapture(this);
  OutilPtLib outilPtLib = new OutilPtLib(this);
  OutilMilieu outilMilieu = new OutilMilieu(this);
  OutilDtAB outilDtAB = new OutilDtAB(this);
  OutilDtPar outilDtPar = new OutilDtPar(this);
  OutilDtPer outilDtPer = new OutilDtPer(this);
  OutilSeg outilSeg = new OutilSeg(this);
  OutilDemiDt outilDemiDt = new OutilDemiDt(this);
  OutilCerOA outilCerOA = new OutilCerOA(this);
  OutilBis outilBis = new OutilBis(this);
  OutilMed outilMed= new OutilMed(this);
  public OutilInt outilInt = new OutilInt(this);
  OutilTranslation outilTrans = new OutilTranslation(this);
  OutilSymAxiale outilSymAxiale = new OutilSymAxiale(this);
  OutilSymCentrale outilSymCentrale = new OutilSymCentrale(this);
  public OutilRapporteur outilRapporteur = new OutilRapporteur(this);
  OutilRot outilRot = new OutilRot(this);
  OutilCerOR outilCerOR = new OutilCerOR(this);
  OutilSup outilSup = new OutilSup(this);
  OutilPtLie outilPtLie = new OutilPtLie(this);
  OutilCalcul outilCalcul = new OutilCalcul(this);
  OutilPtParAbs outilPtParAbs = new OutilPtParAbs(this);
  OutilHom outilHom = new OutilHom(this);
  OutilMesLong outilMesLong = new OutilMesLong(this);
  OutilMesAngNor outilMesAngnor = new OutilMesAngNor(this);
  OutilMesAngOr outilMesAngOr = new OutilMesAngOr(this);
  OutilMesAbs outilMesAbs = new OutilMesAbs(this);
  // Outil servant  faire apparatre le dialogue d'historique
  public OutilHistorique outilHistorique = new OutilHistorique(this);
  // Outil servnt  nommer un point ou une droite
  OutilEntreeNom outilEntreeNom = new OutilEntreeNom(this);
  // Outil servant  cliquer sur les objets qu'on a demand de construire
  OutilPropSol outilPropSol = new OutilPropSol(this);
  
  public String action; // Pour le gestionnaire d'applets pour savoir si l'applet doit
  // sauver via le gestionnaire d'applet les valeurs de res1, ..., res10 auquel cas action
  // doit contenir "Sauvegarde" ou si ces valeurs doivent ?tre restitu?es aux variables
  // res1, ..., res10 auquel cas action doit contenir "Restitution"
  public CMathGrafDoc document ;
  // Rajout pour la version 1.8 : possibilit de recharger une autre figure dans la mme applet
  // Le membre adresseFigure du  type string sera mis  null lors du dmarrage de l'applet.
  /// Lorsqu'on demandera lengthchargement d'une autre figure via ChargeFigure, ce membre
  // sera alors initialis et le thread de chargement relanc
  String adresseFigure = null;
  // statique car charg une seule fois par la premire instance
  FileInputStream file;
  public DimensionFenetre dimf;
  public boolean infRand;
  public InfoProx infoProx;
  // elementProcheCurseur appartient maintenant  l'outil de pointage actif
  // CElementGraphique ElementProcheCurseur;
  public CListeObjets listePr; // Pointeur sur document.listePrincipale
  CListeObjets listeClone; // Utilise comme sauvegarde de la figure dans le cas d'une macro par d?faut
  CListeObjets listeSauve; // Utilise comme sauvegarde de la figure en cas d'appui sur la touche chappement
  public CListeObjets listeConstruction; // Liste utilise pour stocker tous les lments construits par
                                  // l'utilisateur
  private CMacroApparition macroPourCons;
  public CSousListeObjets listeAConstruire; // Pointe sur une liste forme des lments
  // que l'utilisateur doit construire avant de valider sa constriction.
  // null s'il ne s'agit pas d'un exercice de construction
  // La liste d'objets que l'utilisateur dsignera comme solutions
  public CListeObjets listeProposee;
  public CListeObjets listeDependantsDansPrincipale;
  // Nouvelle liste rajoute pour grer les macros jouant un fichier sonore, de faon
  //  lancer un thread chargeant tous les fichiers sonores
  CListeObjets listeMacrosJouantSon;
  // Idem pour la version 1.8 : liste contenant toutes les images
  CListeObjets listeImages;
  // Pour la version 2.0, liste clignotante lors des crations d'objets
  public CListeObjets listeClignotante;
  // Pour la version 2.0, liste forme des objets  ne pas dsigner  la souris
  public CListeObjets listeExclusionDesignation;
  // Pour la version 2.0, liste des objets d'aide  la cration visuelle
  public CListeObjets listeObjetsVisuels;
  public String chaineIndicationPourCons;
  boolean premierAffichage;
  // naturePoint appartient maintenant l'outil de dsignation actif
  // naturePointCapture contient la nature du point qui a t captur  la souris
  // long naturePointCapture;
  // deplacementPointEnCours appartient maitenant  l'outil de capture
  // deplacementPointEnCours contient true si le point captur peut tre dplac
  // boolean deplacementPointEnCours;
  // pointabs et pointres appartiennent maintenant  l'outil de pointage de capture
  // Le champ x de pointabs contient la nouvelle abscisse d'un point
  // li qui doit tre dplac
  // private static Point2D.Double pointabs = new Point2D.Double();
  // pointres continet les nouvelles coordonnes d'un point libre qui doit tre dplac
  // private static Point2D.Double pointres = new Point2D.Double();
  // L'ventuelle image de fond
  Image imageFond = null;
  // macroEnCours sera null lorsqu'aucune macro est en cours d'ex?cution et sinon pointera sur la
  // macro en cours d'ex?cution.
  public CMacro macroEnCours;
  // Si la macro comporte une macro par d?faut qui est une macro de clignotement,
  // macroAnimation contiendra son adresse et l'animation
  // sera continue via un timer appel? animationTimer
  public CMacroAnimationPointLie macroAnimation;
  public CMacro macroParDefaut;
  public java.util.Timer animationTimer;
  // Thread utilis? pour certaines macros
  public Thread runner;
  // Thread utilis pour le chargement de la figure. Pendant ce temps (jusqu'au chargement total)
  // un message de copyright est affich dans la fentre de l'applet. Pour cela une variable
  // boolenne chargementEnCours est utilise
  // Thread utilis pour le chargement des fichiers sonores des macros jouant un fichier sonore
  // La couleur de fond doit tre chang^e dans paint() donc mmorise puisque c'est celle de la figure
  // en cours qui doit  tre choisie
  public Color couleurFond;
  // Variable mise  true si la couleur de fond a t spcifie par le paramtre BackGround
  // Si c'est la cas, elle a priorit sur la couleur du document
  boolean couleurFondParParam;
  public  boolean chargementEnCours = true;

  // MediaTracker pour le chargement d'une ventuelle image de fond
  MediaTracker track;

  public MathGraphTimer timerTask;
  public MathGraphTimer timerTaskAnimation;
  public java.util.Timer timer;
  // Nombre de boutons d'action sur la figure
  private int nombreBoutons;
  // Utilis pour ajouter les boutons aux barres
  private int nbBoutons;

  // Un commentaire destin  tre affich au voisinage du pointeur souris
  public CCommentaire commentaireDesignation; 


  /** Creates new AppletMathGraph32 */
  public AppletMathGraph32() {
    if (nbInstances == 0) {
      appletManager = new AppletManager();
	    // Pour viter un bug de nullPointerException rcursif : 
	    TeXFormula.registerFonts(false);
			// On cre une formule latex pour initialiser tous les fichiers associs
			// et on en profite pour crer un alias de la commande \jlmDynamic qui sert aux insertions dynamiques
			@SuppressWarnings("unused")
			TeXFormula formula = new TeXFormula("\\newcommand{\\Val}[1]{\\jlmDynamic{#1}}");
    }
    nbInstances++;
  }
  
  /**
   * Ajout s'il n'est pas nul du bouton  une des deux barres d'outils
   * en changeant de barres alternativement
   * @param button
   */
  private void ajouteBouton(JMtgButton button) {
    if (button != null) {
      if (nombreBoutons <= nbBoutonsMiniPour3Col) {
        if ((nbBoutons % 2) == 0) bar1.add((button));
        else bar2.add(button);
      }
      else {
        if ((nbBoutons % 3) == 0) bar1.add((button));
        else if ((nbBoutons % 3) == 1) bar2.add((button));
        else bar3.add(button);  
      }
      nbBoutons ++;
      btngroup.add(button);
    }
  }

  public void init() {
        
    // Construction initialise comme fausse
    constructionExacte = false;
    chargementEnCours = true;
    /* Abandonn car provoque des nullPointerException lors de Init
    try
    {
        if (UIManager.getSystemLookAndFeelClassName().indexOf("Windows")!=-1
             || UIManager.getSystemLookAndFeelClassName().indexOf("apple")!=-1)
        {
            UIManager.setLookAndFeel( UIManager.getSystemLookAndFeelClassName());
        }


    } catch (Exception e)
    {
        //Si pb, garder le look par defaut
    }
    */
    document = new CMathGrafDoc();
    // Pour gagner de la rapidit et de la place :
    listePr = document.listePrincipale;
    listeClone = new CListeObjets();
    listeSauve = new CListeObjets();
    // Pour savoir si cette applet doit sauver les valeurs de res1, res2, ..., res10
    // ou au contraire les restituer ? var1, var2, ...., var10
    action = getParameter("Action");
    if (action == null) action = "";
    String coulFond = getParameter("Background");
    couleurFondParParam = (coulFond != null);
    if (couleurFondParParam) couleurFond = Color.decode(coulFond);
    else couleurFond = Color.white;
    Couleur.setCouleurFond(couleurFond);
    chargeApplet();
    try {
      gestionnaire.initialise();
    }
    catch (IOException err) {}
    listeConstruction = new CListeObjets();
    // On ajoute  la liste des objets construits le calcul constant pi
    listeConstruction.add(listePr.get(0));
    listeClignotante = new CListeObjets(listePr.uniteAngle, listePr.pointeurLongueurUnite);
    listeObjetsVisuels = new CListeObjets(listePr.uniteAngle, listePr.pointeurLongueurUnite);
    listeExclusionDesignation = new CListeObjets(listePr.uniteAngle, listePr.pointeurLongueurUnite);
    listeProposee = new CListeObjets(listePr.uniteAngle, listePr.pointeurLongueurUnite);
    // On regarde s'il s'agit d'un exercice de construction.
    // Si non, le pointeur suivant rendra null
    macroPourCons = MacroPourConstruction();
    if (macroPourCons != null) {
      listeAConstruire = macroPourCons.listeAssociee;
      chaineIndicationPourCons = macroPourCons.commentaireMacro;
    }
    
    // Si on est dans le cas d'un exercice de construction
    if (macroPourCons != null) {
      // Impossible d'utiliser setToolTipText pour les boutons  cause de
      // l'affichage par buffer du Jpanel qui contient la figure
      // Prparation de la zone de texte d'indications
      //indicationArea.setEnabled(false);
      indicationArea.setEditable(false);
      indicationArea.setForeground(Color.BLUE);
      indicationArea.setSelectionColor(Color.WHITE);
      indicationArea.setSelectedTextColor(Color.BLUE);
      informationArea.setEditable(false);
      informationArea.setForeground(Color.BLUE);
      informationArea.setSelectionColor(Color.WHITE);
      informationArea.setSelectedTextColor(Color.BLUE);
      // Cration du groupe de boutons
      btngroup = new ButtonGroup();
      // On compte le nombre rel de boutons
      nombreBoutons = 0;
      buttonAnnuler = outilAnnuler.boutonAssocie();
      nombreBoutons++;
      buttonRefaire = outilRefaire.boutonAssocie();
      nombreBoutons++;
      buttonSup = outilSup.boutonAssocie();
      nombreBoutons++;     
      buttonHistorique = outilHistorique.boutonAssocie();
      nombreBoutons++;           
      buttonNommer = outilEntreeNom.boutonAssocie();
      nombreBoutons++;           
      buttonCapt = outilCapture.boutonAssocie();
      nombreBoutons++;           
      buttonPtLib = outilPtLib.boutonAssocie();
      if (buttonPtLib != null) nombreBoutons++;
      buttonPtLie = outilPtLie.boutonAssocie();
      if (buttonPtLie != null) nombreBoutons++;
      buttonMil = outilMilieu.boutonAssocie();
      if (buttonMil!= null) nombreBoutons++;
      buttonSeg = outilSeg.boutonAssocie();
      if (buttonSeg != null) nombreBoutons++;
      buttonDteAB = outilDtAB.boutonAssocie();
      if (buttonDteAB != null) nombreBoutons++;
      buttonDtePar = outilDtPar.boutonAssocie();
      if (buttonDtePar != null) nombreBoutons++;
      buttonDtePer = outilDtPer.boutonAssocie();
      if (buttonDtePer != null) nombreBoutons++;
      buttonDteMed = outilMed.boutonAssocie();
      if (buttonDteMed != null) nombreBoutons++;
      buttonDteBis = outilBis.boutonAssocie();
      if (buttonDteBis != null) nombreBoutons++;
      buttonDemiDt = outilDemiDt.boutonAssocie();
      if (buttonDemiDt != null) nombreBoutons++;
      buttonCerOA = outilCerOA.boutonAssocie();
      if (buttonCerOA != null) nombreBoutons++;
      buttonCerOR = outilCerOR.boutonAssocie();
      if (buttonCerOR != null) nombreBoutons++;
      buttonInt = outilInt.boutonAssocie();
      if (buttonInt != null) nombreBoutons++;
      buttonTrans = outilTrans.boutonAssocie();
      if (buttonTrans != null) nombreBoutons++;
      buttonSymAxiale = outilSymAxiale.boutonAssocie();
      if (buttonSymAxiale != null) nombreBoutons++;
      buttonSymCentrale = outilSymCentrale.boutonAssocie();
      if (buttonSymCentrale != null) nombreBoutons++;
      buttonRot = outilRot.boutonAssocie();
      if (buttonRot != null) nombreBoutons++;
      buttonRapp = outilRapporteur.boutonAssocie();
      if (buttonRapp != null) nombreBoutons++;
      buttonCreerCalcul = outilCalcul.boutonAssocie();
      if (buttonCreerCalcul != null) nombreBoutons++;
      buttonPtParAbs = outilPtParAbs.boutonAssocie();
      if (buttonPtParAbs != null) nombreBoutons++;
      buttonHom = outilHom.boutonAssocie();
      if (buttonHom != null) nombreBoutons++;
      buttonMesLong = outilMesLong.boutonAssocie();
      if (buttonMesLong != null) nombreBoutons++;
      buttonMesAngNor = outilMesAngnor.boutonAssocie();
      if (buttonMesAngNor != null) nombreBoutons++;
      buttonMesAngOr = outilMesAngOr.boutonAssocie();
      if (buttonMesAngOr != null) nombreBoutons++;
      buttonMesAbs = outilMesAbs.boutonAssocie();
      if (buttonMesAbs != null) nombreBoutons++;
      buttonPropSol = outilPropSol.boutonAssocie();

      bar1.setMargin(new Insets(0,0,0,0));
      bar2.setMargin(new Insets(0,0,0,0));
      bar3.setMargin(new Insets(0,0,0,0));
      
      // Un JPane pour contenir le bouton de proposition de solution et le bouton
      // de choix de couleur
      bar4 = new JPanel();
      bar4.setLayout(new GridBagLayout());
       
      bar1.setFloatable(false);
      bar2.setFloatable(false);
      bar3.setFloatable(false);
      // bar4.setFloatable(false);
      
      nbBoutons = 0;
      ajouteBouton(buttonAnnuler);
      ajouteBouton(buttonRefaire);
      ajouteBouton(buttonHistorique);
      ajouteBouton(buttonCapt);
      ajouteBouton(buttonSup);
      ajouteBouton(buttonNommer);
      ajouteBouton(buttonPtLib);
      ajouteBouton(buttonMil);
      ajouteBouton(buttonDteAB);
      ajouteBouton(buttonSeg);
      ajouteBouton(buttonDemiDt);
      ajouteBouton(buttonDtePar);
      ajouteBouton(buttonDtePer);
      ajouteBouton(buttonDteMed);
      ajouteBouton(buttonDteBis);
      ajouteBouton(buttonCerOA);
      if (listePr.pointeurLongueurUnite != null) ajouteBouton(buttonCerOR);
      ajouteBouton(buttonInt);
      ajouteBouton(buttonRapp);
      ajouteBouton(buttonTrans);
      ajouteBouton(buttonSymAxiale);
      ajouteBouton(buttonSymCentrale);
      ajouteBouton(buttonRot);
      ajouteBouton(buttonHom);
      ajouteBouton(buttonPtLie);
      ajouteBouton(buttonCreerCalcul);
      ajouteBouton(buttonPtParAbs);
      if (listePr.pointeurLongueurUnite != null) ajouteBouton(buttonMesLong);
      ajouteBouton(buttonMesAngNor);
      ajouteBouton(buttonMesAngOr);
      ajouteBouton(buttonMesAbs);
      btngroup.add(buttonPropSol);
      
      if (nombreBoutons <= nbBoutonsMiniPour3Col) paneLeftHigh.setLayout(new GridLayout(1,2));
      else paneLeftHigh.setLayout(new GridLayout(1,3));
      paneLeftHigh.add(bar1);
      paneLeftHigh.add(bar2);
      if (nombreBoutons > nbBoutonsMiniPour3Col) paneLeftHigh.add(bar3);

      GridBagConstraints constraints = new GridBagConstraints();
      constraints.insets.bottom = 0;
      constraints.insets.top = 0;
      constraints.insets.left = 0;
      constraints.insets.right = 0;
      MtgDlg.setConstraints(constraints, 0, 0, 1, 1, 100, 50, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
      bar4.add(buttonPropSol, constraints);
      
      colorButton = new JMtgColorButton(this);
      colorButton.addMouseListener(this);
      MtgDlg.setConstraints(constraints, 0, 1, 1, 1, 0, 50, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
      bar4.add(colorButton, constraints);
      paneLeftLow.add(bar4);
      // On cre le dialogue de choix de couleurs
      colorChooser = new JColorChooser();
      colorChooser.setPreviewPanel(new JPanel()); // Pour qu'il n'y ait pas de preview
      colorChooser.setColor(colorButton.couleur);

      paneLeft.setLayout(new BorderLayout());
      paneLeft.add("North",paneLeftHigh);
      paneLeft.add("Center",paneLeftLow);
      paneSouth.setLayout(new GridLayout(2,1));
      paneSouth.add(indicationArea);
      paneSouth.add(informationArea);

      panePrincipal.setLayout(new BorderLayout());
      panePrincipal.add("West",  paneLeft);
      panePrincipal.add("Center", paneFigure);
      panePrincipal.add("South", paneSouth);
      // panePrincipal.add(("South"), informationArea);
      setContentPane(panePrincipal);
      Rectangle rect1 = paneLeft.getBounds();
      decalageBordGauche = rect1.width;
      rect1 = paneSouth.getBounds();
      decalageBordBas = rect1.height;
      activeOutilCapture();
    }
    else { // Cas d'un exercice qui n'est pas un exercice de construction
      setContentPane(paneFigure);
      outilActif = outilCapture;
      outilCapture.select();
    }
      
    setCursor(OutilPointage.defaultCursor);


    // A revoir

    infRand = false;

    //dimf = new DimensionFenetre(getWidth(), getHeight());
    // Les dimensions horizontales de la figure ne sont pas celles de l'applet
    // pour cette version avec barre d'outils de construction
    dimf = new DimensionFenetre(getWidth()-decalageBordGauche, getHeight()-decalageBordBas);
    infoProx = new InfoProx();
    // Le point qui sert ? suivre les mouvements de la souris pour la cr?ation visuelle
    pointSouris = new CPointBase(listeExclusionDesignation, null, false);
    // Commentaire li au point prcdent servant  l'affichage des dsignations au
    // voisinage du pointeur souris
    commentaireDesignation = new CCommentaire(listePr, null, false,
            Couleur.TraduitCouleur(4), 0d, 0d, 0d, 0d, false,
            pointSouris, 2, StyleEncadrement.Sans, false, Couleur.TraduitCouleur(0), "");

    track = null;
    premierAffichage = true;
    //deplacementPointEnCours = false;
    //repaint();

    // addMouseMotionListener(this);
    // addMouseListener(this);
    addKeyListener(this);
    setFocusable(true);
    requestFocus(); 
    // panePrincipal.addKeyListener(this);
    // paneFigure.addKeyListener(this);
    paneFigure.addMouseMotionListener(this);
    paneFigure.addMouseListener(this);
    premierAffichage = true;
    chargementEnCours = false;
    historiqueDlg = new HistoriqueDlg(this);
    start();
    repaint();
  }
 
/**
 * @return Fonction renvoyant null si la figure ne contient pas un exercice de construction.
 * Dans le cas contraire, la figure doit contenir une macro d'apparition d'objet
 * nomme SolutionConstruction dont la liste d'objets  faire apparatre
 * sera en fait la liste des objets que l'utilisateur de l'applet doit construire.
 * le commentaire de cette macro contiendra des informations que l'on affichera
 * dans la ligne d'indication pour dire quel est le type d'objet que l'utilisateur
 * doit cliquer. Chacun commencera par un caractre du type #1: suivi de l'indication
 *  afficher
 */
  private CMacroApparition MacroPourConstruction() {
    ListIterator<CElementBase> li = listePr.listIterator();
    while (li.hasNext()) {
      CElementBase elb = (CElementBase) li.next();
      if (elb.getClass() == CMacroApparition.class) {
        CMacroApparition mac = (CMacroApparition) elb;
        if ((mac.intitule.compareToIgnoreCase(textes.Chaines.solutionConstruction) == 0)
        		|| (mac.intitule.compareToIgnoreCase("SolutionConstruction") == 0)) return mac;
      }
    }
    return null;
  }
  // Il faut redfinir la mthode update car par dfaut elle efface le contenu de 
  // la fentre avec la couleur de fond avant d'appeler paint(), ce qui provoque un effet de flash
  public void update(Graphics graphics) {
    paint(graphics);
  }
  
  
  /**  Par dfaut, lors d'un repaint, la figure n'est pas recalcule
   *   Appeler cette fonction pour recalculer la figure puis la
   *   rafficher en particulier lors de termineAction() des macros
  **/
  public void repaintFigureAvecCalcul() {
    positionne();
    paneFigure.afficheToutDansgbuffer();
    paneFigure.repaint();
  }

  /**  Par d?faut, lors d'un repaint, la figure n'est pas recalcul?e
   *   Appeler cette fonction pour recalculer la figure puis la
   *   r?afficher en particulier lors de termineAction() des macros
  **/
  public void repaintFigureSansCalcul() {
    paneFigure.afficheToutDansgbuffer();
    paneFigure.repaint();
  }
  
  
public void repaintFigure() {
  paneFigure.repaint();
}

public void dessinegbuffer() {
  paneFigure.dessinegbuffer((Graphics2D) paneFigure.getGraphics());
}
  /** La mthode paint() a t profondment remanie dans la version 2.0
   *  L'ide principale est toujours la mme : dessiner dans la fentre
   *  principale exclusivement avec paint()
   *  La figure n'est dessine dans le gbuffer dans paint() que lors du premier
   *  affichage, except lors de la capture d'objets.
   *  Il faut donc dessiner ce qu'il faut dans le gbuffer avant d'appeler repaintFigure()
   *  Par exemple, pour le clignotement des objets dsigns lors de la cration
   *  dans la mthode run() de MathGraphTimerClig, on dessine ou efface la liste
   *  clignotante dans le gbuffer avant appel  repaintFigure()
   */
  
  
  public void start() {
    timerTaskAnimation = new MathGraphTimer(this);
    if (macroEnCours != null) {
      if (macroEnCours.executionEnCours) {
        macroEnCours.macroEnCours().initialiseInterruptions(this);
      }
    }
    // Avec le chargement de la figure par un thread, start() est appel avant le chargement
    // et ainsi on ne peut pas initialiser le timer  cet endroit au premier chargement.
    // Cela va tre fait dans paint()
    if (macroAnimation != null) {
      macroAnimation.actionAvantExecution(this);
      if (animationTimer == null) {
        animationTimer = new java.util.Timer();
        animationTimer.schedule(timerTaskAnimation, 0l, macroAnimation.frequenceAnimation());
      }
    }
  }

  // Si la page internet qui contient l'applet n'est plua active, il faut arr^ter tout timer oui thread
  // dclench par l'utilisation d'une macro et lengthrecharger ensuite dans start quand la page
  // est ractive.
  public void stop() {
    if (timer != null) {
      timer.cancel();
      timer = null;
    }
    if (animationTimer != null) {
      animationTimer.cancel();
      animationTimer = null;
    }
    timerTask = null;
    timerTaskAnimation = null;
    runner = null;
    //if (runner != null) runner = null;(
    //if (timer != null) timer = null;
    //if (animationTimer != null) {
    //  timerTaskAnimation = null;
    //  animationTimer.cancel();
    //  animationTimer = null;
    //}

  }

  public void destroy() {
  }
  
  // Activation de l'outil de capture
  public final void activeOutilCapture() {
    if (outilActif != null) outilActif.deselect();
    outilActif = outilCapture;
    buttonCapt.setSelected(true);
    outilActif.select();
  }

  // Dans la version 20, il faut ragir aux clics sur les boutons
  public void actionPerformed(ActionEvent e) {
    if (chargementEnCours) return;
    Object ob = e.getSource();
    if (ob.getClass() == JMtgButton.class) {
      JMtgButton jb = (JMtgButton) ob;
      Outil outilChoisi = ((JMtgButton) ob).outil;
      // On regarde si l'outil choisi peut ?tre activ?
      if (outilChoisi.activationValide()) {
        outilActif.deselect();
        outilActif = outilChoisi;
        outilChoisi.select();
        jb.requestFocus();
        
      }
      else {
        dialogueAvertissement(textes.Chaines.ch15);
        // jb.setEnabled(false);
        // buttonCapt.grabFocus();
        outilChoisi.deselect();
        // jb.setSelected(false);
        // On r?active l'outil de capture si l'outil ne peut pas ?tre activ?
        activeOutilCapture();
      }   
    }
  }
  
  // Dans la version 2.0, ce n'est plus l'applet qui g?re ce message,
  // mais le panneau figurePane intance de JMtgPanel
  // La m?thode MousePressed de ce panneau appelle MousePressedOnFig;      
  public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
    if (chargementEnCours) return;
    Object ob = mouseEvent.getSource();
    if (ob == paneFigure) {
      outilPointageActif.mousePressed(mouseEvent);
    }
  }

  // Dans la version 2.0, ce n'est plus l'applet qui g?re ce message,
  // mais le panneau figurePane intance de JMtgPanel
  // La mthode MouseReleased de ce panneau appelle MouseReleasedOnFig;      
 
  public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {
    if (chargementEnCours) return;
    Object ob = mouseEvent.getSource();
    if (ob == paneFigure) {
      outilPointageActif.mouseReleased(mouseEvent);
    }
  }
  
  public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
  }
  
  public void mouseExited(java.awt.event.MouseEvent mouseEvent) {
    Object ob = mouseEvent.getSource();
    if ((ob.getClass() == JMtgButton.class) || ob.getClass() == JMtgColorButton.class) {
      information("");        
    }
    else showStatus("");
  }
  
  public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {
    Object ob = mouseEvent.getSource();
    setCursor(OutilPointage.macroCursor);
    if (ob.getClass() == JMtgButton.class) {
        information(((JMtgButton) ob).outil.chaineInfo());
    }
    else {
      if (ob.getClass() == JMtgColorButton.class) {
        information (textes.Chaines.chaineInfo27);
      }
      else showStatus("Applet MathGraph32 V2.4.2 Copyright (C) Yves Biton 2006 -> Under Gnu GPL3 License");    
      // On affiche dans la  barre du navigateur un message de copyright
    }
  }
  
  public void mouseMoved(java.awt.event.MouseEvent mouseEvent) {
    if (chargementEnCours) return;
    Object ob = mouseEvent.getSource();
    if (ob == paneFigure) {
      pointSouris.placeEn(mouseEvent.getX(), mouseEvent.getY());
      outilPointageActif.mouseMoved(mouseEvent);
    }
  }

  public void mouseDragged(java.awt.event.MouseEvent mouseEvent) {
    if (chargementEnCours) return;
    Object ob = mouseEvent.getSource();
    if (ob == paneFigure) {
      outilPointageActif.mouseDragged(mouseEvent);
    }
  }

  public void run() {
    Thread thisThread = Thread.currentThread();
    while( runner == thisThread) {
      if (macroEnCours != null) {
        macroEnCours.macroEnCours().executePourThread(this);
      }
    }
  }
  
  public void keyTyped(KeyEvent evt) {
    if ((evt.getKeyChar() == KeyEvent.VK_ESCAPE)) {
      if (macroEnCours != null) {
        macroEnCours.termineAction(this);
        /*
        timerTask = null;
        if (timer != null){
          timer.cancel();
          timer = null;
        }
        if (runner != null) runner = null;
        */
				try {
					Thread.sleep(100); // Pour laisser le temps aux boucles en cours
															// d'excution de se terminer
				} catch (InterruptedException e) {
				}        
        macroEnCours = null;
      }
      //premierAffichage = true;
      listePr.positionne(infRand, dimf);
      listeSauve.positionne(infRand, dimf);
      listePr.setClone(listeSauve); // Doit tre appel aprs positionne()
      paneFigure.effacegBuffer();
      paneFigure.afficheToutDansgbuffer();
      paneFigure.repaint();
    }     
  }

  public void keyReleased(KeyEvent evt) {
  }
  
  public void keyPressed(KeyEvent evt) {
  }
  
    
  //final static void prepareCurseurMacro() {
  //  // Construction du curseur souris d'ex?cution d'une macro
  //  Toolkit kit = Toolkit.getDefaultToolkit();
  //  Dimension dim = kit.getBestCursorSize(8, 8);
  //  int w = dim.width;
  //  int h = dim.height;
  //  BufferedImage bi = new BufferedImage(w, h, BufferedImage.TYPE_4BYTE_ABGR);
  //  WritableRaster r = bi.getRaster();
  //  Color colorTrait = Couleur.TraduitCouleur(1);
  //  int[] couleurTrait = new int[4];
  //  couleurTrait[0] = colorTrait.getRed();
  //  couleurTrait[1] = colorTrait.getGreen();
  //  couleurTrait[2] = colorTrait.getBlue();
  //  couleurTrait[3] = 255; // Le trait remplace ce qu'il recouvre
  //  Color colorOrange = Color.orange;
  //  int[] couleurOrange = new int[4];
  //  couleurOrange[0] = colorOrange.getRed();
  //  couleurOrange[1] = colorOrange.getGreen();
  //  couleurOrange[2] = colorOrange.getBlue();
  //  couleurOrange[3] = 255; // Le trait remplace ce qu'il recouvre
  //  Color colorFond = Couleur.TraduitCouleur((byte)0);
  //  int[] couleurFond = new int[4];
  //  couleurFond[0] = colorFond.getRed();
  //  couleurFond[1] = colorFond.getGreen();
  //  couleurFond[2] = colorFond.getBlue();
  //  couleurFond[3] = 0; // La couleur de fond est transparente
  //  for (int i = 0; i < w; i++) {
  //    for (int j = 0; j < h; j++) {
  //      r.setPixel(i, j, couleurFond);
  //    }
  //  }
  //  int d = 14; 
  //  for (int i = 4; i <= d; i ++) {
  //    r.setPixel(2, i, couleurTrait);
  //    r.setPixel(3, i, couleurTrait);
  //    r.setPixel(4, i, couleurOrange);
  //    r.setPixel(5, i, couleurTrait);
  //    r.setPixel(6, i, couleurTrait);
  //  }
  //  r.setPixel(0, 4, couleurTrait);
  //  r.setPixel(1, 4, couleurTrait);
  //  r.setPixel(7, 4, couleurTrait);
  //  r.setPixel(8, 4, couleurTrait);
  //  r.setPixel(1, 3, couleurTrait);
  //  r.setPixel(7, 3, couleurTrait);
  //  for (int i = 0; i < 4; i ++) {
  //    r.setPixel(i, 4 - i, couleurTrait);
  //    r.setPixel(8 - i, 4 - i, couleurTrait);
  //  }
  //  r.setPixel(4, 0, couleurTrait);
  //  for (int i = 0; i < 3; i ++) {
  //    for (int j = 2 + i;  j <= 6 - i; j ++) {
  //      r.setPixel(j, 3 - i, couleurOrange);
  //    }
  //  }
  //  macroCursor = kit.createCustomCursor(bi, new Point(4, 0),"");
  //}
  /* Fonction renvoyant le chemin d'accs  la figure sans le nom */
  String cheminAcces() {
    String ch = getParameter("Path");
    int i = ch.lastIndexOf('/');
    if (i == -1) return "";
    else return ch.substring(0,i+1);
  }
  
  // Mthode chargeant l'applet et appele depuis un thread
  void chargeApplet() {
    try
    {
      String chAcces = cheminAcces();
      // On regarde si un chargement d'une nouvelle figure a t demand via
      // chargeFigure
      String adFig;
      if (adresseFigure == null) adFig = getParameter("Path");
      else {
        adFig = chAcces + adresseFigure;
        paneFigure.effacegBuffer();
      }
      // A voir plus tard une fois les commentaires crs
      // if (s == null) {
      // On charge une ventuelle image de fond
      // Abandonn. Ne marche pas dans l'explorer
      //if (NbInstance == 1) prepareCurseurMacro(); // Doit tre aprs la couleur de fond dtermine
      URL adresse = new URL(getDocumentBase(),adFig);
      BufferedInputStream buff = new BufferedInputStream(adresse.openStream());
      MathGraphDataInputStream dataStream = new MathGraphDataInputStream(buff);
      document.chargeDepuisFlux(dataStream);
      // On regarde si une couleur de fond est spcifie dans la figure.
      if (!couleurFondParParam) {
        couleurFond = document.couleurFond;
      }
      listePr.setCopy(listeClone);
      listePr.setCopy(listeSauve);
      listeDependantsDansPrincipale = new CListeObjets(listePr);
      listeMacrosJouantSon = new CListeObjets(listePr);
      listeMacrosJouantSon.ajouteMacrosJouantSon(listePr);
      listeImages = new CListeObjets(listePr);
      listeImages.ajouteImages(listePr);
      String imfond = new String();
      if (document.pathImageFond.length() == 0) {
        String s = getParameter("Image");
        if (s != null) imfond = s;
      }
      else {
        imfond = document.pathImageFond;
      }
      boolean imageFondPresente = imfond.length() != 0;
      imfond = chAcces + imfond;
      // On attend le chargement de toutes les images 
      if ((listeImages.size() != 0) || (imageFondPresente)) {
        Toolkit kit = Toolkit.getDefaultToolkit();
        track = new MediaTracker(this);
        int indiceIm = 0;
        if (imageFondPresente) {          
          URL adr = new URL(getDocumentBase(),imfond);
          imageFond = kit.getImage(adr);
          track.addImage(imageFond, indiceIm);
          indiceIm++;
        }
        CListeObjets list = listeImages;
        ListIterator<CElementBase> li = list.listIterator();
        while(li.hasNext()) {
          CImage im = (CImage) (li.next());
          URL adr = new URL(getDocumentBase(),chAcces + im.imagePath);
          im.image = kit.getImage(adr);
          track.addImage(im.image, indiceIm);
          indiceIm++;
        }
      }    
      // On attend que l'ventuelle image de fond soit charge
      if (track != null) {
        try {
          track.waitForAll();
        }
        catch (InterruptedException e) { }
      }
      // Si ncessaire on charge les fichiers sonores des macros jouant des sons
      if (listeMacrosJouantSon.size() != 0) {
        CListeObjets list = listeMacrosJouantSon;
        ListIterator<CElementBase> li = list.listIterator();
        while(li.hasNext()) {
          CMacroJouantSon mac = (CMacroJouantSon) (li.next());
          mac.clip = getAudioClip(getDocumentBase(), mac.wavePath);
        } 
      }
      macroParDefaut = listePr.macroParDefaut;
      if (macroParDefaut != null) {
        if (macroParDefaut instanceof CMacroAnimationPointLie)  {
          macroAnimation = (CMacroAnimationPointLie) macroParDefaut;
          macroParDefaut = null;
          long freq = macroAnimation.frequenceAnimationMacro;
          if (freq < 10) macroAnimation.frequenceAnimationMacro = 10;
          //macroAnimation.actionAvantExecution(this);
        }
      }
      // Une fois l'applet entirement charge, et si son paramtre Action
      // contenait "Restitution", on affecte le contenu des calculs res1, res2, ..., res10
      // de la figure prcdemment sauvegardes via l'AppletManger
      // aux variables var1, var2, ..., var10 de faon  pouvoir "reconstituer"
      // la figure de l'applet prcdente
      if (action.compareTo("Restitution") == 0) {
        appletManager.restitueValeurs(this);
      }
    }
    catch (Exception e) {
      System.out.println("Erreur pendant le chargement");
      System.out.println(e.getMessage() + e.toString());
      System.exit(-1);
    }
  }
  
  // Nouveau pour la version 1.8
  // Pour les macros devant laisser une trace, initialise le device context de traces
  // en l'effa?ant et en affichant l'image de fond s'il y en a une
  public void initilizetbuffer()
  {
    paneFigure.effacetBuffer();
    if (imageFond != null) paneFigure.tbuffer.drawImage(imageFond, 0, 0, this);  
  }
   
  
  // Mthode publique destine  excuter une macro via JavaScript.
  // Prend comme paramtre l'initul de la mthode (doit respecter la casse et les espaces)
  // Renvoie true si l'ex?cution a public avoir lieu et false sinon
  public final boolean executeMacro(String NomMacro) {
    // Refus si la macro poss?de une macro par d?faut qui est une macro d'animation
    if (macroAnimation != null) return false;
    // On cherche si NomMacro contient bien un intitul de macro valide
    CMacro macroAExecuter = listePr.pointeurMacro(NomMacro);
    if (macroAExecuter == null) return false;
    
    if (macroEnCours != null) { // Si aucune macro n'est d?j? en cours d'ex?cution
                              // on lance l'ex?cution de la macro cliqu?e si possible
      CMacro mac = macroEnCours.macroEnCours();
      mac.termineAction(this);
      macroEnCours.termineAction(this);
    } 
    if (macroAExecuter.executionPossible()) {
      macroEnCours = macroAExecuter;
      macroEnCours.initialise(this);
      macroEnCours.macroEnCours().actionAvantExecution(this);
      // Si la macro utilise un thread, il faut le cr?er.
      // ? revoir
      macroEnCours.macroEnCours().initialiseInterruptions(this);

      if (macroEnCours.macroEnCours().typeAnimation() == CMacro.sansAnimation) repaint();
      return true;
    }
    else return false;
  }
  
  // Version 1.8 : M?thode publique destin?e ? recharger une autre figure via JavaScript.
  public final void chargeFigure(String nomFigure) {
  	// Impossible de charger une autre figure si la figure en cours est un exercice de construction
    if (macroPourCons != null) return;  	
    stop();
    adresseFigure = nomFigure;
    chargementEnCours = true;
    timerTaskAnimation = null;
    macroEnCours = null;
    macroAnimation = null;
    animationTimer = null;
    imageFond = null;
    // On d?truit le document actuel
    document = new CMathGrafDoc();
    listePr.clear();
    listePr = document.listePrincipale;
    listeClone.clear();
    listeSauve.clear();
    listeConstruction.clear();
    listeDependantsDansPrincipale.clear();
    listeMacrosJouantSon.clear();
    System.gc();
    premierAffichage = true;
    chargeApplet();
    repaint();
    chargementEnCours = false;
    start();
  }
  
  // Version 1.8 : M?thode publique destin?e ? conna?tre la valeur d'un calcul
  // Renvoie -1 si le calcul n'est pas d?fini ou n'existe pas. Sinon renvoie
  // sa valeur
  public final double valeurDe(String nomCalcul) {
    // Si l'exercice est une exercice de construction et si on demande
    // la valeur d'un calcul nomm reponse qui en fait n'existe pas on revoie true
    // si les objets dsigns avce l'outil outilPropSol sont les bons
    if ((macroPourCons != null) && (nomCalcul.compareToIgnoreCase("reponse") == 0)) {
      if (constructionExacte) return 1; else return 0;
    }
    CCalcul calcul = listePr.pointeurCalculOuFonction(nomCalcul, -1);
    if (calcul == null) return -1;
    // Pas de retirage al?atoire
    else {
      if ((!calcul.existe) || calcul.getClass() != CCalcul.class) return -1;
      else return calcul.resultat;
   }
  }
  
  // Version rectifie le 18/3/09
  // Le troisime paramtre n'est plus utilis et n'est gard
  // que pour compatibilit avec les versions antrieures
  // Version 1.8 : Mthode publique donnant la valeur correspond au contenu de
  // la chane chCalcul au calcul ou  la fonction de nom nomCalcul.
  // Renvoie 1 si tout s'est bien pass.
  // Renvoie 0 si mne  un calcul n'existant pas
  // Renvoie -1 s'il y a une faute de syntaxe
  // Renvoie -2 si le calcul ou la fonction n'existe pas.
  // La figure n'est pas repositionnes et raffiche aprs l'affectation
  // de la valeur  la variable.
  // Il faut pour cela appeler redessine()
  
  public final int donneValeurA(String nomCalcul, String chCalcul, String variableFormelle) {
    @SuppressWarnings("unused")
		double v;
    CCalculBase calc;
    // On remplace les virgules par des points dcimaux
    chCalcul = chCalcul.replace(',', '.');
    CCalcul valeur = listePr.pointeurCalculOuFonction(nomCalcul, -1);
    if (valeur == null) return -2;
    else {
      String varf;
      // Modification pour la version CNED
      // boolean bcalcul = (variableFormelle.length() == 0);
      boolean bFonction = (valeur.getClass() == CFonc.class);
      if (bFonction) varf = ((CFonc) valeur).chaineVariable; else varf = null;
      Int indErr = new Int();
      if (!CCalculBase.verifieSyntaxe(listePr, chCalcul, indErr, 
          listePr.indexOf(valeur)-1, varf))
        return -1;
      if (bFonction) {
        calc = CCalculBase.creeCalculBase
          (chCalcul ,listePr, 0, chCalcul.length()-1, varf);        
        valeur.chaineCalcul = chCalcul;
        valeur.calcul = calc;
        return 1;
      }
      else {
        calc = CCalculBase.creeCalculBase
          (chCalcul ,listePr, 0, chCalcul.length()-1, varf);
        try {
          v = calc.resultat(false);
        }
        catch (ErreurCalculException e) {
          return 0;
        }
        valeur.chaineCalcul = chCalcul;
        valeur.calcul = calc;
        return 1;        
      }
    }
  }
   
  
  // Version 1.8 : M?thode publique destin?e ? savoir si une macro est en cours d'ex?cution
  public final boolean macroEnCours() {
    return (macroEnCours != null);
  }
  
  // Version 1.8 : Mthode publique destine  savoir si la figure est bien charg?e
  public final boolean figureChargee() {
    return !chargementEnCours;
  }
  
  /**
   * Version 1.8 : mthode publique servant  recalculer et rafficher compltement la figure
   * en effaant tout, recalculant et affichant tout.
   * Sauvegarde les donnes pour rtroaction
   */
  public final void redessine() {
    positionne();
    if (action.compareTo("Sauvegarde") == 0) {
      appletManager.sauveValeurs(this);
    }
    paneFigure.effacegBuffer();
    paneFigure.afficheToutDansgbuffer();
    paneFigure.repaint();
  }
  
  /**
   * Ajout pour la version 2.5.4 pour sauvegarder les valeurs
   * dans une aplet de validation interne.
   */
  public final void sauvegarde() {
    if (action.compareTo("Sauvegarde") == 0) {
      appletManager.sauveValeurs(this);
    }    
  }
  /**
   * Version 1.8 : mthode publique servant  recalculer et rafficher compltement la figure
   * en effaant tout et raffichant tout sans recalculer tout et sans sauvegarde pour rtroaction.
   * Sauvegarde les donnes pour rtroaction
   */  
  public void redessineSansCalcul() {
    paneFigure.effacegBuffer();
    paneFigure.afficheToutDansgbuffer();
    paneFigure.repaint();    
  }
  // Lors du positionnement de la liste principale de l'applet, si le
  // param?tre Action de celle-ci contenait "Sauvegarde", il faut sauvegarder
  // via l'AppletManager les valeurs de res1,res2, ..., res10 (si elles existent)
  public final void positionne() {
    listePr.positionne(infRand, dimf);
  }
  
  /* Fonction positionnat la liste pour la cration visuelle d'objets */
  public void positionneListeVisuelle() {
    listeObjetsVisuels.positionne(infRand, dimf);
  }
  
  /* Fonction affichant un dialogue d'avertissement */
  public void dialogueAvertissement(String texte) {
    JOptionPane.showMessageDialog(null, texte, "Avertissement", JOptionPane.WARNING_MESSAGE);
  }
  /* Fonction affichant un dialogue demandant une rponse oui-non et renvoyant
   * true si la rponse est oui
   **/
  public boolean dialogueYesNo(String texte) {
   return  (JOptionPane.showConfirmDialog(null, texte, "A confirmer", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION);
  }
  /* Fonction rajoutant un objet  la liste principale
   * Il faut pour cela mettre  zro la liste clone et la cloner  nouveau */
  public void ajouteElement(CElementBase pt) {
  	pt.positionne(false, dimf);
    CElementBase ptClone = pt.getClone(listePr, listeClone);
    listeClone.add(ptClone);
    listePr.add(pt);
    listeConstruction.add(pt);
    listeClone.setClone(listePr);
  }
  /* Fonction rajoutant un objet ? la liste des objets visuels */
  public void ajouteObjetVisuel(CElementBase pt) {
    listeObjetsVisuels.add(pt);
  }
  
  /* Fonction rajoutant un objet  la liste principale
   * Il faut pour cela mettre  zro la liste clone et la cloner  nouveau
   * Renvoie true si l'lment n'a pas dj t cr
   */
  public boolean ajouteElementAvecVerification(CElementBase pt) {
    if (!listeConstruction.existeDeja(pt)) {
      ajouteElement(pt);
      // positionne();
      return true;
    }
    else {
      dialogueAvertissement(textes.Chaines.ch7);
      return false;
    }
  }
  /* Fonction dtruisant le dernier objet de la liste ListePr et de sa liste
   * clone listeClone */
  public void detruitDernierElement() {
    listeClone.detruitDernierObjet();
    listePr.detruitDernierObjet();
    listeConstruction.detruitDernierObjet();
    listeProposee.detruitDernierObjet();
  }
  // Idem avec destruction des n derniers lments
  public void detruitNDerniersElements(int n) {
    for (int i = 0; i < n; i++) {
      detruitDernierElement();
    }
  }
  
  
  // Affichage d'une chaine d'indication dans la zone JTextArea en bas de l'?cran
  /**
   * Affichage d'une chaine d'indication dans la zone JTextArea en bas de l'?cran
   */
  public void indication(String ch) {
    indicationArea.setText(ch);
    indicationArea.repaint();
  }
  
  public void information(String ch) {
    informationArea.setText(ch);
    informationArea.repaint();
  }

  public void retireDependants(CElementBase pt) {
    int indice = listePr.indexOf(pt);
    listePr.retireDependants(pt);
    annuleSolutionProposee();
    etablitListeObjetsConstruits();
    CElementBase ptclone = (CElementBase) listeClone.get(indice);
    listeClone.retireDependants(ptclone);
  }
  
  public int nombreObjetsInitiaux() {
    return listeSauve.size();
  }
  
  public void etablitListeObjetsConstruits() {
    int nbo = nombreObjetsInitiaux();
    listeConstruction = new CListeObjets();
    // On ajoute  la liste des objets construits le calcul constant pi de la liste principale
    // de faon  pouvoir l'utiliser dans les calculs
    listeConstruction.add(listePr.get(0));    
    for (int i = nbo; i < listePr.size(); i++) {
      listeConstruction.add(listePr.get(i));
    }  
  }
  /**
   * Fonction renvoyant une chane permettant  l'utilisateur de savoir quel est
   * l'objet ni qu'il doit dsigner quand il dsigne les objets qu'on lui a demand de coNStruire
   * @param i
   * @return
   */
  public String indicationSol(int i)
  {
    String ret = "";
    String ch = "#" + glob.Kernel.chaineNombre(i, 0) +":";
    int j = chaineIndicationPourCons.indexOf(ch);
    if (j != -1)
    {
      int k = chaineIndicationPourCons.indexOf("#", j + ch.length());
      if (k != -1)
      {
        ret = chaineIndicationPourCons.substring(j + ch.length(), k);
      }
      else ret = chaineIndicationPourCons.substring(j + ch.length());
      // Recherche de retour chariot et saut
      int m = ret.indexOf("\r\n");
      if (m != -1) ret = ret.substring(0,m);
    // On ne prend que les 80 premiers caractres
    if (ret.length() > 80) ret = ret.substring(0, 81);
    }
    return ret;
  }
  /**
   * 
   * @return true si les objets qui ont t cliqus et sont contenus dans listeProposee
   * sont confondus avec ceux qu'ils faut construire contenus dans listeAConstruire
   */
  private boolean reponseValideUnePasse() {
    boolean res = true;
    int nbo = listeAConstruire.size();
    for (int i = 0; (i < nbo) && res; i++) {
      CElementBase elb1 = (CElementBase) listeAConstruire.get(i);
      boolean res2 = false;
      for (int j = 0; (j< nbo) && !res2; j++) {   
        CElementBase elb2 = (CElementBase) listeProposee.get(j);
        res2 = res2 || elb1.coincideAvec(elb2);
      }
      res = res && res2;
    }
    return res;
  }
  public boolean reponseValide() {
    // On regarde d'abord si les objets proposs coincident bien avec ceux 
    // construire
  	// listeClone.setClone(listePr);
    boolean res = reponseValideUnePasse();
    if (!res) return false;
    // La liste listeClone contient des clones des objets dans l'tat o ils sont actuellement
    // On remet les lments du texte de la figure dans l'tat o ils taient au chargement
    // de la figure.
    // C'est ncessaire car la mthode de vrification va dplacer lgrement
    // les points mobiles pour tester la validit de la rponse et ils faut que la
    // construction reste possible lors de ces dplacements
    listePr.setClone(listeSauve);  // Le clonage n'est fait que pour les lments initiaux de la figure
    listePr.positionne(infRand, dimf);
    CListeObjets listePtsLibres = new CListeObjets();
    CListeObjets listePtsLies = new CListeObjets();
    int nbo = listeSauve.size();
    for (int j = 0; j < nbo; j++) {
      CElementBase elb = (CElementBase) listePr.get(j);
      if ((elb.getNature() == NatureObjet.NPointBase) && (listeAConstruire.dependDe(elb)))
        listePtsLibres.add(elb);
      if ((elb.getNature() == NatureObjet.NPointLie) && (listeAConstruire.dependDe(elb)))
        listePtsLies.add(elb);
    }
    // On va 3 fois de suite dplacer un peu les points libres et lis dont dpendent
    // les objets  construire et qui font partie de la figure initiale et regarder
    // si la solution reste valide. Si oui elle sera accepte sinon refuse
    // listeClone.setClone(listePr);
    for (int i = 0; (i < 3) && res; i++) {
      // On dplace un peu les points libres et lis
      ListIterator<CElementBase> li1 = listePtsLibres.listIterator();
      while (li1.hasNext()) {
        CPointBase ptb = (CPointBase) li1.next();
        epsilon(ptb);
      }
      ListIterator<CElementBase> li2 = listePtsLies.listIterator();
      while (li2.hasNext()) {
        CPointLie ptl = (CPointLie) li2.next();
        epsilon(ptl);
      }
      listePr.positionne(infRand, dimf);
      res = res && reponseValideUnePasse();
      listePr.setClone(listeSauve);
      listePr.positionne(infRand, dimf);
    }
    // On remet les objets dans la position o les a mis l'utilisateur
    listePr.setClone(listeClone);
    return res;
  }
  
  /**
   * Fonction repositionnant lgrement (maximum 5 piles en + ou en - dans
   * chaque direction le point libre ptb
   * Utilis lors de la validation de la rponse
   * @param ptb
   */
  private void epsilon(CPointBase ptb) {
    double x1 = 0;
    double y1 = 0;
    double a = Math.floor(Math.random()*5) + 1;
    double b = Math.floor(Math.random()*5) + 1;
    double s1 = Math.floor(Math.random()*2);
    double s2 = Math.floor(Math.random()*2);
    if (s1 == 0) x1 = a; else x1 = -a;
    if (s2 == 0) y1 = b; else y1 = -b;
    ptb.placeEn(ptb.x + x1, ptb.y + y1);
  }
  /**
   * Fonction donnant  l'abscisse du point li une nouvelle valeur s'cartant au maximum
   * de 5 % vers la haut ou la bas par rapport  l'abscisse initiale.
   * @param ptl
   */
  private void epsilon(CPointLie ptl) {
    double absmin = ptl.abscisseMinimale();
    double absmax = ptl.abscisseMaximale();
    // on dcale l'abscisse au maximum de 5% vers la haut ou vers la bas au hasard
    double a = Math.floor(Math.random()*5) + 1;
    double s1 = Math.floor(Math.random()*2);
    if (s1 == 0) a  = -a;
    double nabs = ptl.abscisse + a*(absmax - absmin)/100;
    if (nabs > absmax) nabs = absmax;
    else if (nabs < absmin) nabs = absmin;
    ptl.donneAbscisse(nabs);
  }
  /**
   * Fonction renvoyant true lorsque l'exercice n'est pas un exercice de construction
   * ou lorsque l'exercice est unn exercice de construction et que l'utilisateur
   * a bien dsign tous les objets qu'il pense tre ceux qu'on lui demandait de construire
   * @return
   */
  public boolean solutionProposee() {
    if (macroPourCons == null) return true;
    return (listeAConstruire.size() == listeProposee.size());
  }
  
  /**
   * Renvoie la couleur active qui est donne par le bouton colorButton
   * @return
   */
  public Color couleurActive() {
    return colorButton.couleur;
  }
  /**
   * Renvoie la nature des objets dont on peut crer l'image par une transformation
   * Les points sont autoriss.
   * Ne sert que pour un exercice de construction
   * Les droites sont autorises si la macro macroPourCons  un commentaire qui
   * contient la squence de caractres ImageDroite. Idem pour les demi-droites
   * cercles et arcs de cercles
   * @return
   */
  public long natureObjetsPourImages() {
    long res = NatureObjet.NToutPoint;
    if ((chaineIndicationPourCons.indexOf(textes.Chaines.imageDroite) != -1)
    	|| (chaineIndicationPourCons.indexOf("imageDroite") != -1)) res |= NatureObjet.NDroite;
    if ((chaineIndicationPourCons.indexOf(textes.Chaines.imageDemiDroite) != -1)
    	|| (chaineIndicationPourCons.indexOf("imageDemiDroite") != -1))res |= NatureObjet.NDemiDroite;
    if ((chaineIndicationPourCons.indexOf(textes.Chaines.imageCercle) != -1) 
    	|| (chaineIndicationPourCons.indexOf("imageCercle") != -1))res |= NatureObjet.NCercle;
    if ((chaineIndicationPourCons.indexOf(textes.Chaines.imageArc) != -1) 
    	|| (chaineIndicationPourCons.indexOf("imageArc") != -1))res |= NatureObjet.NArc;
    return res;
  }
  /**
   * Fonction mettant  chane vide la chaine utilise pour la dsignation d'objets
   */
  public void videDesignation() {
    commentaireDesignation.donneChaine("");
  }
  /**
   * Fonction retirant tous les objets de la liste utilise pour proposer une solution
   * 
   */
  public void annuleSolutionProposee() {
    listeProposee.retireTout();
  }
  
  // Version 2.0 : mthode publique servant  remettre la figure dans l'tat o
  // elle tait  l'issu de son premier affichage
  public final void reset()
  {
    if (macroPourCons != null) {
      if (macroEnCours != null) {
        macroEnCours.termineAction(this);
        timerTask = null;
        if (timer != null){
          timer.cancel();
          timer = null;
        }
        if (runner != null) runner = null;
        macroEnCours.termineAction(this);
        macroEnCours = null;
      }
      listeConstruction.retireTout();
      listePr.retireTout();
      listeSauve.setCopy(listePr);
      listePr.setClone(listeSauve);
      //premierAffichage = true;
      activeOutilCapture();
      paneFigure.effacegBuffer();
      repaintFigureAvecCalcul();
      repaint();
    }
  }
}
