/*
 * AngleRotDlg.java
 *
 * Created on 4 juillet 2006, 14:41
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package dialogs;

import javax.swing.*;

import objets.*;

import java.awt.event.*;
import java.awt.*;
import Applet.*;

/**
 *
 * @author Yves
 * Bote de dialogue utilise pour entrer l'angle d'une rotation
 */
@SuppressWarnings("serial")
public class AngleRotDlg extends MtgDlg implements ActionListener {
  private EditeurAngle editeurAngle;
  private JButton btnOK, btnCancel,btnListeVal;
  private CRotation rot;
  /** Creates a new instance of AngleRotDlg */
  public AngleRotDlg(AppletMathGraph32 appletInit, CRotation rotInit) {
    super(null, textes.Chaines.ch11, true, appletInit);
    setResizable(false);
    rot = rotInit;
    JLabel label = new JLabel(textes.Chaines.angleRotDlg1, SwingConstants.LEFT);
    editeurAngle = new EditeurAngle(applet, rot.angle, rot, applet.listePr.uniteAngle);
    editeurAngle.setSelectedIndex(-1);
    btnCancel = new JButton(textes.Chaines.btnCancel);
    btnOK = new JButton(textes.Chaines.btnOK);
    btnListeVal = new JButton(textes.Chaines.listeValeurs);
    
    JPanel pane = new JPanel();
    pane.setLayout(new GridBagLayout());
    JPanel paneBas = new JPanel(); // Pour contenir les boutons OK et Cancel
    paneBas.setLayout(new GridBagLayout());
    
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    
    setConstraints(constraints, 0, 0, 1, 1, 40, 40, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(label, constraints);
    
    setConstraints(constraints, 1, 0, 1, 1, 60, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    constraints.insets.bottom = 0;
    pane.add(editeurAngle, constraints);
    constraints.insets.bottom = 5;
    
    setConstraints(constraints, 0, 1, 2, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.EAST);
    pane.add(btnListeVal, constraints);
    
    setConstraints(constraints, 0, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    paneBas.add(btnOK, constraints);

    setConstraints(constraints, 1, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    paneBas.add(btnCancel, constraints);
    
    setConstraints(constraints, 0, 2, 2, 1, 0, 30, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
    pane.add(paneBas, constraints);
    
    setContentPane(pane);
    btnOK.addActionListener(this);
    btnCancel.addActionListener(this);
    btnListeVal.addActionListener(this);
    getRootPane().setDefaultButton(btnOK);
    pack();
  }
  public void actionPerformed(ActionEvent evt) {
    if (evt.getSource()== btnOK) {
      // Si la rponse est valide, on ferme la boite de dialogue sans la dtruire.
      // VrifieValidite se charge de changer l'angle de la rotation si la rponse est
      // correcte.
      if (editeurAngle.verifieValidite()) {
        
        setRetourOK(true);
        dispose();
      }
    }
    else {
      if (evt.getSource() == btnCancel) {
        dispose();
      }
      else {
        if (evt.getSource() == btnListeVal) {
          int indmax = applet.listeConstruction.indexOf(rot);
          if (indmax == -1) indmax = applet.listeConstruction.size() - 1;
          else indmax -= 1;
          ListeValeursComboDlg dlg = new ListeValeursComboDlg(applet, editeurAngle, indmax);
          dlg.setLocationRelativeTo(null); // Pour centrer la boite de dialogue sur l'cran
          dlg.setVisible(true);
        }
      }
    }
    // La variable retourOK a t initialie  false donc tous les autres cas n'on pas  tre traits
  }  
}
