/*
 * RayonDlg.java
 *
 * Created on 11 juillet 2006, 08:56
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package dialogs;

import javax.swing.*;

import objets.*;

import java.awt.event.*;
import java.awt.*;
import Applet.*;
  

/**
 *
 * @author Yves
 * Dialogue d'entre ou de modification du rayon d'un cercle
 */

@SuppressWarnings("serial")
public class RayonDlg extends MtgDlg implements ActionListener {

  private EditeurRayon editeurRayon;
  private JButton btnOK, btnCancel,btnListeVal;
  private CCercleOR cercle;
  
  /** Creates a new instance of RayonDlg */
  public RayonDlg(AppletMathGraph32 appletInit, CCercleOR cercleInit) {
    super(null, textes.Chaines.rayonDlg1, true, appletInit);
    setResizable(false);
    cercle = cercleInit;
    JLabel label = new JLabel(textes.Chaines.rayonDlg1, SwingConstants.LEFT);
    editeurRayon = new EditeurRayon(applet, cercle.R, cercle);
    btnCancel = new JButton(textes.Chaines.btnCancel);
    btnOK = new JButton(textes.Chaines.btnOK);
    btnListeVal = new JButton(textes.Chaines.listeValeurs);
    
    JPanel pane = new JPanel();
    pane.setLayout(new GridBagLayout());
    JPanel paneBas = new JPanel(); // Pour contenir les boutons OK et Cancel
    paneBas.setLayout(new GridBagLayout());
    
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 40, 40, GridBagConstraints.NONE, GridBagConstraints.WEST);
    pane.add(label, constraints);
    
    setConstraints(constraints, 1, 0, 1, 1, 60, 0, GridBagConstraints.NONE, GridBagConstraints.WEST);
    constraints.insets.bottom = 0;
    pane.add(editeurRayon, constraints);
    constraints.insets.bottom = 5;
    
    setConstraints(constraints, 0, 1, 2, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.EAST);
    pane.add(btnListeVal, constraints);
    

    setConstraints(constraints, 0, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.EAST);
    paneBas.add(btnOK, constraints);

    setConstraints(constraints, 1, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
    paneBas.add(btnCancel, constraints);
    
    setConstraints(constraints, 0, 2, 2, 1, 0, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
    pane.add(paneBas, constraints);
    
    setContentPane(pane);
    
    btnOK.addActionListener(this);
    btnCancel.addActionListener(this);
    btnListeVal.addActionListener(this);
    getRootPane().setDefaultButton(btnOK);    
    pack();
  }
  public void actionPerformed(ActionEvent evt) {
    if (evt.getSource()== btnOK) {
      // Si la rponse est valide, on ferme la boite de dialogue sans la dtruire.
      // VrifieValidite se charge de changer l'angle de la rotation si la rponse est
      // correcte.
      if (editeurRayon.verifieValidite()) {
        
        setRetourOK(true);
        dispose();
      }
    }
    else {
      if (evt.getSource() == btnCancel) {
        dispose();
      }
      else {
        if (evt.getSource() == btnListeVal) {
          int indmax = applet.listeConstruction.size() - 1;
          ListeValeursTextFieldDlg dlg = new ListeValeursTextFieldDlg(applet, editeurRayon, indmax);
          dlg.setLocationRelativeTo(null); // Pour centrer la boite de dialogue sur l'cran
          dlg.setVisible(true);
        }
      }
    }
    // La variable retourOK a t initialie  false donc tous les autres cas n'on pas  tre traits
  }
 
}
