/*
 * CAffichageLieAPoint.java
 *
 * Created on 27 juillet 2004, 18:36
 */

/**
 *
 * @author  Yves
 * @version
 */

package objets;

import java.awt.*;
import java.io.*;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.*;

// Modification pour la version 1.9.5
// A la suite du rajout des lieux d'objets cette classe n'est plus abstract
public  class CAffichageLieAPoint extends CElementGraphique {
  public CPointAncetre pointLie;  // null si li  aucun point
  // Dans la version Pascal, il y avait un membre TailleCaractere
  // qui est maintenant remplac par IndiceTaillePolice
  public int indiceTaillePolice;
  // A partir de la version 2.5, encadrement n'est plus booln
  // Si encadrement vaut 0, pas d'encadrement. S'il vaut 1, encadrement simple
  // et s'il vaut 2 encadrement 3D
  public int encadrement; // mis  true pour que l'affichage soit encadr
  public boolean effacementFond; // mis  true pour que le fond soit effac
  //avant l'affichage des caractres
  public Color couleurFondAffichage; // Ajout pour la version 2.5. N'est srialis que si EffacementFond est  true;
  Rectangle rectangleAffichage; // Coordonnes du rectangle contenant la
  //valeur affichee en coordonnes logiques
  // InfoRandom n'tant disponible que dans positionne(), il faut mmoriser la chaine  afficher
  private String chaineAAfficher;
  // Pour l'affichage en relief des intituls de macros
  int xEncadrement;
  int yEncadrement;
  int widthEncadrement;
  int heightEncadrement;
  
  /** Creates new CAffichageLieAPoint */
  public CAffichageLieAPoint() {
    rectangleAffichage = new Rectangle();
  }
  
  // Constructeur pour clonage
  public CAffichageLieAPoint(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
    CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
    boolean effacementFondInit, Color couleurFondInit) {
      super(liste, impProtoInit, estElementFinalInit, couleurInit, dec_xInit, dec_yInit, masqueInit);
      x_nom = x_nomInit;
      y_nom = y_nomInit;
      pointLie = pointLieInit;
      indiceTaillePolice = indiceTaillePoliceInit;
      encadrement = encadrementInit;
      effacementFond = effacementFondInit;
      couleurFondAffichage = couleurFondInit;
      rectangleAffichage = new Rectangle();
  }
  
  
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    rectangleAffichage.setRect(((CAffichageLieAPoint)ptel).rectangleAffichage);
    chaineAAfficher = ((CAffichageLieAPoint)ptel).chaineAAfficher;
  }
  
  // Version 1.9.5 : cette mthode n'est plus abstract et doit tre redfinie
  // pour les descendants
  protected String rendChaineAffichage(boolean infoRandom){
    return "";
  }
  
  @Override
  public void ajouteAntecedents(CListeObjets liste) {
    if (pointLie != null) liste.add(pointLie);
  } 
  
  public boolean dependDe(CElementBase p) {
    if (pointLie == null)
      return super.dependDe(p);
    else
      return super.dependDe(p) || pointLie.dependDe(p) ;
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    if (pointLie == null)
      return (p == this);
    else
      return (p == this) || pointLie.dependDePourBoucle(p) ;
  }
  
// Lors des captures de points
// inutile d'effacer les affichages sauf si le point auquel il
// est ventuellement li en dpend.
  public boolean dependDePourCapture(CElementBase p) {
    return dependDe(p);
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    if (pointLie != null) existe = pointLie.existe;
    else existe = true;
    if (!existe) return;
    if (pointLie != null) {
      if (pointLie.horsEcran) {
        existe = false;
        return;
      }
      // Java :  revoir.
      x_nom = pointLie.x; //
      y_nom = pointLie.y; //
    }
    chaineAAfficher = rendChaineAffichage(infoRandom);
  }
  
  public double distancePoint(double xp, double yp, boolean masquage) {
    if (!existe || (masquage && masque)) return -1;
    else {
      if (rectangleAffichage.contains(xp, yp)) return 0;
      else return -1;
    }
  }
  
  // Java : changement par rapport au C++. Lors du positionnement, le device context n'est pas
  // accessible et on ne peut pas avoir d'objet FontMetrics. Le membre rectangleAffichage ne peut
  // donc pas tre tabli  ce niveau.
  // Il le sera dans l'affichage puisque l'effacement arrive toujours aprs.
  @Override
  public void affiche(Graphics2D pDC, boolean masquage, Color couleurFond, float transparence) {
  	// Il faut afficher un tel objet mme avec l'outil rideau quand il est masqu
  	if (!masque || (masque && !masquage)) {
      rectangleAffichage.x = (int) (x_nom + dec_x);
      rectangleAffichage.y = (int) (y_nom + dec_y);
      Kernel.dimensionsChaine(pDC, indiceTaillePolice, chaineAAfficher, rectangleAffichage, listeProprietaire.basseDefinition );
      trace(pDC, couleurFond, transparence);
    }
  }
  
  // Java :  revoir. On peut optimiser l'effacement dans le cas d'un effacement
  // du fond
  // Modifi pour la version 1.3.1
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
    boolean basseDefinition = listeProprietaire.basseDefinition;
    if ((chaineAAfficher.length() == 0)) return;
    pDC.setStroke(Pinceau.CreePinceau(StyleTrait.traitFin)); // Pour le rectangle
    // d'encadrement ventuel et les flches de vecteur ventuelles
    if (basseDefinition) {
	    xEncadrement = rectangleAffichage.x - 3;
	    yEncadrement = rectangleAffichage.y - 2;
	    widthEncadrement = rectangleAffichage.width + 5;
	    heightEncadrement = rectangleAffichage.height + 2;
    } else {
      // Les dimensions suivantes sont diffrentes dans l'applet car l'espace de coordonnes est 100 fois plus grand
      // et il y a des problmes d'arrondi
      xEncadrement = rectangleAffichage.x - 40;
      yEncadrement = rectangleAffichage.y - 30;
      widthEncadrement = rectangleAffichage.width + 100;
      heightEncadrement = rectangleAffichage.height + 50;    	
    }
    
 
    if (effacementFond) {
      pDC.setColor(couleurFondAffichage);
      // Les bords bas et droits ne sont pas compris semble-t-il par fillRect
      // Diffrence par rapport  la version C++ V1.8
      if (encadrement != 0)
        pDC.fillRect(xEncadrement, yEncadrement, widthEncadrement, heightEncadrement);
      else
        pDC.fillRect(rectangleAffichage.x, rectangleAffichage.y,
          rectangleAffichage.width, rectangleAffichage.height);
      
    }
    pDC.setColor(couleur);
    Kernel.afficheChaine(pDC, indiceTaillePolice, chaineAAfficher, rectangleAffichage.x,
    		rectangleAffichage.y, basseDefinition);
    if (encadrement != 0) {
      pDC.setColor(couleur);
      pDC.drawRect(xEncadrement, yEncadrement, widthEncadrement, heightEncadrement);
    }
    
    if (encadrement == StyleEncadrement.Effet3D) {
    	if (basseDefinition) {
	      int x1 = xEncadrement + widthEncadrement + 1;
	      int y1 = yEncadrement + heightEncadrement + 1;
	      pDC.drawLine(xEncadrement + 1, y1, x1, y1);
	      pDC.drawLine(x1, yEncadrement + 1, x1, y1);
    	}
    	else {
    		int x = xEncadrement + widthEncadrement;
    		int y = yEncadrement + heightEncadrement;
        int x1 = x + 10;
        int y1 = y + 10;
        for (int j = 1; j <= 10; j++) {
	        pDC.drawLine(xEncadrement + j, y + j, x1, y + j);
	        pDC.drawLine(x + j, yEncadrement + j, x + j, y1);
        }
    	}
    }
  }
  
  public void translateDe(double decalagex, double decalagey) {
  	x_nom += decalagex;
  	y_nom += decalagey;
  }
  
	/**
	 * Adaptation de certains objets pour passer en haute rsolution avant
	 * impression notamment
	 */
  @Override
	public void adaptePourHauteResolution() {
  	super.adaptePourHauteResolution();
		x_nom *= 10;
		y_nom *= 10;
	}
  
    
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    if (ind1 == -1) pointLie = null;
    else pointLie = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    indiceTaillePolice = inps.readByte();
    x_nom = inps.readCDouble()/10;
    y_nom = inps.readCDouble()/10;
    encadrement = inps.readUnsignedByte();
    effacementFond = inps.readBoolean();
    // Modification pour le passage en version RVB  partir de la version 2.5 (n5)
    if ((effacementFond) && (listeProprietaire.numeroVersion >=5)) {
      int r = inps.readUnsignedByte();
      int g = inps.readUnsignedByte();
      int b = inps.readUnsignedByte();
      @SuppressWarnings("unused")
			int a = inps.readUnsignedByte();
      couleurFondAffichage = new Color(r,g,b,255);
    }
    // Ligne suivante modifie version 2.0
    // else couleurFond = Couleur.TraduitCouleur(0);
    else couleurFondAffichage = listeProprietaire.documentProprietaire.couleurFond;
  }
  /* Chargement depuis un flux java */
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    if (ind1 == -1) pointLie = null;
    else pointLie = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    indiceTaillePolice = inps.readByte();
    x_nom = inps.readDouble();
    y_nom = inps.readDouble();
    encadrement = inps.readUnsignedByte();
    effacementFond = inps.readBoolean();
    // Modification pour le passage en version RVB  partir de la version 2.5 (n5)
    if (effacementFond) {
      int r = inps.readUnsignedByte();
      int g = inps.readUnsignedByte();
      int b = inps.readUnsignedByte();
      couleurFondAffichage = new Color(r,g,b,255);
    }
    else couleurFondAffichage = Couleur.TraduitCouleur(0);
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1;
    if (pointLie == null) ind1 = -1;
    else ind1 = list.indexOf(pointLie);
    oups.writeInt(ind1);
    oups.writeByte(indiceTaillePolice);
    oups.writeDouble(x_nom);
    oups.writeDouble(y_nom);
    oups.writeByte(encadrement);
    oups.writeBoolean(effacementFond);
    if (effacementFond) {
      oups.writeByte(couleurFondAffichage.getRed());
      oups.writeByte(couleurFondAffichage.getGreen());
      oups.writeByte(couleurFondAffichage.getBlue());
    }
  }
  
  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
    if (pointLie == ancienPoint) pointLie = nouveauPoint;
  }
}
