/*
 * CCalcConst.java
 *
 * Created on 3 juillet 2004, 18:33
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;

import types.DimensionFenetre;
import types.NatureCalcul;

import entreesSorties.MathGraphDataInputStream;

public class CCalcConst extends CCalcul {

  /** Creates new CCalcConst */
  public CCalcConst() {
  }
  /**
   * Constructeur pour cration d'objet
   * @param liste
   * @param impProtoInit
   * @param estElementFinalInit
   */
  public CCalcConst(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit) {
    super(liste, impProtoInit, estElementFinalInit);
  }
  
  // Constructeur pour clonage
  public CCalcConst(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      String nomCalculInit, String chaineCalculInit, CCalculBase calculInit) {
    super(liste, impProtoInit, estElementFinalInit, nomCalculInit, chaineCalculInit, calculInit);
    calculeValeurConstante();
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CCalculBase calculClone = calcul.getClone(listeSource, listeCible);
    int ind1 = listeSource.indexOf(impProto);
    return new CCalcConst(listeCible, (CImplementationProto)(listeCible.get(ind1, CImplementationProto.class)),
      estElementFinal, nomCalcul, chaineCalcul, calculClone);
  }
  
  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NCalculReelConstant;
  }
  
  // Rajout pour la version 2.0
  public void calculeValeurConstante()
  {
    // Les paramtres passs n'ont aucune importance.
    // On calcule la valeur de la cosntante qu ne peut tre que pi dans cette version
    super.positionne(false, new DimensionFenetre(0,0));
  }
  // Positionne ne fait rien car la valeur constante est calcule au chargement de l'objet
  // ou lors du clonage
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = true;
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps,list);
    calculeValeurConstante();
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    calculeValeurConstante();
  }
}
