package objets;

import java.awt.Color;
import java.io.IOException;
import types.DimensionFenetre;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CCentreCercle extends CPointAncetre {
	private CCercle cercleAssocie;
	
  /**
   * Constructeur pour serialization
  */
  public CCentreCercle() { 
  }
	
  /** Constructeur pour clonage*/
  public CCentreCercle(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean nomMasqueInit, double dec_xInit, double dec_yInit, boolean masqueInit,
    String nomInit, int indiceTailleNomInit, int motifInit, CCercle cercleAssocieInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, nomMasqueInit,
      dec_xInit, dec_yInit, masqueInit, nomInit, indiceTailleNomInit, motifInit);
    cercleAssocie = cercleAssocieInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(cercleAssocie);
    int ind2 = listeSource.indexOf(impProto);
    CElementBase ptelb = new CCentreCercle(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, nomMasque, dec_x, dec_y, masque, nom, indiceTailleNom, motif,
      (CCercle)(listeCible.get(ind1, CCercle.class)));
    return ptelb;
  }
  
  @Override
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || cercleAssocie.dependDe(p);
  }
  
  @Override
  public boolean dependDePourBoucle(CElementBase p) {
    return (p == this) || cercleAssocie.dependDePourBoucle(p);
  }
  
  @Override
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = cercleAssocie.existe;
    if (existe) super.placeEn(cercleAssocie.centre_x, cercleAssocie.centre_y);
  }
  
  @Override
	public boolean confonduAvec(CElementBase p) {
    CCentreCercle pt;
    if (p.getClass() == this.getClass()) {
      pt = (CCentreCercle) p;
      return cercleAssocie == pt.cercleAssocie;
    }
    else return false;
	}
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    cercleAssocie = (CCercle) (list.get(ind1,CCercle.class));
  }
  
  /* Enregistrement dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    cercleAssocie = (CCercle) (list.get(ind1,CCercle.class));
    
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(cercleAssocie);
    oups.writeInt(ind1);
  }   
}
