/*
 * CCommentaire.java
 *
 * Created on 1 aot 2004, 21:39
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.*;
import java.io.*;
import java.util.StringTokenizer;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.*;

public class CCommentaire extends CAffichageLieAPoint {
	public String chaineCommentaire;
	// Nouveau pour la version 1.8.
	// Il faut maintenir une liste dont les lments pointent sur les valeurs
	// affiches par ce commentaire
	public CListeObjets listeValeursDynamiquesUtilisees;
  // La chaine d'affichage est la chane relle  afficher pes qu'on ait regard s'il y a
  // des valeurs dynamiques dans lengthcommentaire
  private String chaineAffichage;
  /** Creates new CCommentaire */
  public CCommentaire() {
  }
  
  // Constructeur pour clonage
  public CCommentaire(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
      boolean effacementFondInit, Color couleurFondInit, String chaineCommentaireInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit,
          indiceTaillePoliceInit, encadrementInit, effacementFondInit, couleurFondInit);
        chaineCommentaire = chaineCommentaireInit;
        listeValeursDynamiquesUtilisees = new CListeObjets(liste.uniteAngle, liste.pointeurLongueurUnite);        
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    // Corrig lors de la version 2.0
    int ind1 = listeSource.indexOf(pointLie);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CCommentaire(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y,
      masque, (CPointAncetre)listeCible.get(ind1, CPointAncetre.class), indiceTaillePolice, encadrement,
      effacementFond, couleurFondAffichage, chaineCommentaire);
    ((CCommentaire) ptelb).listeValeursDynamiquesUtilisees = 
      new CListeObjets(listeCible.uniteAngle, listeCible.pointeurLongueurUnite);
    if (listeCible.getClass() != CPrototype.class) ((CCommentaire) ptelb).determineDependances();
    return ptelb;
  }
  
  // Rajout pour version 2.0. Un commentaire est utilis pour les affichages fugitifs
  // au voisinage du pointeur de souris.
  // Fonction servant  changer la chane affiche par le commentaire
  public void donneChaine(String chaine) {
    chaineCommentaire = chaine;
  }
  
  // Rajout pour la version 2.0 pour la mme raison que plus haut.
  public void placeEn(int x, int y, int decx, int decy) {
    x_nom = x;
    y_nom = y;
    dec_x = decx;
    dec_y = decy;
  }
    
  // Inutile de redfinir efface()
  public String rendChaineAffichage(boolean infoRandom) {
  	return chaineAffichage;
  }
 
  //  Nouveau pour version 1.9 pour l'affichage de formule (sert pour l'applet)
  // Renvoie true dans formule s'il s'agit d'un affichage de formule et false sinon
  int indicePremierValOuForm(int indDeb, Bool formule)
  {
    int indVal = chaineCommentaire.indexOf("#Val(", indDeb);
    int indFor = chaineCommentaire.indexOf("#For(", indDeb);
    if ((indVal == -1) && (indFor == -1)) return -1;
    if (((indVal > indFor) || (indVal == -1)) && (indFor != -1))
    {
      formule.setValue(true);
      return indFor;
    }
    else
    {
      formule.setValue(false);
      return indVal;
    }
  }
  
  // Nouveau pour la version 1.8.
  // Doit tre appel lors de la srialization (chargement), lors de la cration d'un
  // commentaire ou de sa modification.
  // Est similaire  Positionne() et doit le rester
  public void determineDependances()
  {
    Bool bformule = new Bool(true);
    listeValeursDynamiquesUtilisees.retireTout();
    // On examine la chaine  la recherche de #Val(
    int len = chaineCommentaire.length();
    int jdeb;
    int j = 0;
    if ((chaineCommentaire.indexOf("#Val(",j) == -1) 
      && (chaineCommentaire.indexOf("#For(",j) == -1))
    {
      return;
    }
    while (((jdeb = indicePremierValOuForm(j, bformule)) != -1) && j < len)
    {
      // On recherche la parenthse fermante correspondante
      int indparf = chaineCommentaire.indexOf(')',jdeb + 5);
      if (indparf == -1)
      {
        j = len + 1;
      }
      else
      {
        // On recherche aussi un ventuel retour  la ligne
        int indsaut = chaineCommentaire.indexOf('\n',jdeb + 5);
        if ((indsaut !=  -1) && (indsaut < indparf))
        {
          j = indsaut + 1;
        }
        else
        {
          // On cre une chaine form de ce qu'il y a entre #Val( et la parenthse fermante
          String ch = chaineCommentaire.substring(jdeb+5, indparf);
          // On retire les ventuels espaces de cete chaine
          int k;
          while((k = ch.indexOf(' ', 0)) != - 1)
          {
            ch = ch.substring(0,k) + ch.substring(k+1);
          }
          // On spare cette chaine avec les virgules
          StringTokenizer st = new StringTokenizer(ch, ",",false);
          if (! st.hasMoreTokens())
          {
            j = indparf + 1;
          }
          else
          {
            String nomvaleur = st.nextToken();
            // On recherche si c'est bien le nom d'une valeur valide
            // Il ne faut pas que la valeur ait t dfinie aprs l'affichage de valeur
            int indicecommentaire = listeProprietaire.indexOf(this);
            // Trs important : quand determineDependnaces est appel
            // par getClone() de CCommentaire, lengthcommentaire n'a pas encor t rajout
            //  la liste clone et ainsi indiceCommentaire renvoie -1.
            // dans ce cas, indiceCommentaire doit valoir le nombre d'lments actuels
            // de la liste clone qui le possde
            if (indicecommentaire == -1) indicecommentaire = listeProprietaire.size() - 1;
            CValeurDynamique pValeur = listeProprietaire.pointeurValeurOuFonction
              (nomvaleur,indicecommentaire);
            if (pValeur == null)
            {
              j = indparf + 1;
            }
            else
            {
              if (((bformule.getValue()) && ((pValeur.getClass() == CCalcul.class)
                      || (pValeur.getClass() == CFonc.class)))
                  || !bformule.getValue()) {
                listeValeursDynamiquesUtilisees.add(pValeur);
              }
              // Si la valeur n'existe pas, on ne l'inclut pas dans la chane  afficher
              j = indparf + 1;
            }
          }
        }
      }		
    }
  } 
  
  // Pour la version 1.8, positionne() est redfini
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    Bool bformule = new Bool(true);
    // On examine la chaine  la recherche de #Val(
    int len = chaineCommentaire.length();
    StringBuffer bufferAffichage = new StringBuffer(len+128);;
    int jdeb;
    int j = 0;
    if ((chaineCommentaire.indexOf("#Val(",j) == -1) 
      && (chaineCommentaire.indexOf("#For(",j) == -1)) {
        chaineAffichage = chaineCommentaire;
        super.positionne(infoRandom, dimfen);
        return;
    }
    while (((jdeb = indicePremierValOuForm(j, bformule)) != -1) && j < len)
    {
      bufferAffichage.append(chaineCommentaire.substring(j, jdeb));
      // On recherche la parenthse fermante correspondante
      int indparf = chaineCommentaire.indexOf(")",jdeb + 5);
      if (indparf == -1)
      {
        bufferAffichage.append(chaineCommentaire.substring(jdeb, len));
        j = len + 1;
      }
      else
      {
        // On recherche aussi un ventuel retour  la ligne
        int indsaut = chaineCommentaire.indexOf('\n',jdeb + 5);
        if ((indsaut !=  -1) && (indsaut < indparf))
        {
          bufferAffichage.append(chaineCommentaire.substring(jdeb, indsaut+2));
          j = indsaut + 1;
        }
        else
        {
          // On cre une chaine form de ce qu'il y a entre #Val( et la parenthse fermante
          String ch = chaineCommentaire.substring(jdeb+5, indparf);
          // On retire les ventuels espaces de cete chaine
          int k;
          while((k = ch.indexOf(' ', 0)) != - 1)
          {
            ch = ch.substring(0, k) + ch.substring(k+1);
          }
          // On spare cette chaine avec les virgules
          StringTokenizer st = new StringTokenizer(ch, ",",false);
          if (! st.hasMoreTokens())
          {
            bufferAffichage.append(chaineCommentaire.substring(jdeb, indparf+1));
            j = indparf + 1;
          }
          else
          {
            String nomvaleur = st.nextToken();
            // On recherche si c'est bien le nom d'une valeur valide
            // Il ne faut pas que la valeur ait t dfinie aprs l'affichage de valeur
            // Si c'est le nom d'une valeur utilise, elle est comprise dans la
            // liste listeValeursDynamiquesUtilisees
            int indfin = listeValeursDynamiquesUtilisees.size() - 1;
            CValeurDynamique pValeur = listeValeursDynamiquesUtilisees.
              pointeurValeurOuFonction(nomvaleur,indfin);
            if (pValeur == null)
            {
              bufferAffichage.append(chaineCommentaire.substring(jdeb, indparf+1));
              j = indparf + 1;
            }
            else
            {
              
              // Si la valeur n'existe pas, on ne l'inclut pas dans la chane  afficher
              if (pValeur.existe)
              {
                if (bformule.getValue()) {
                // L'affichage de formule n'a de sens que pour un calcul ou une fonction
                  if ((pValeur.getClass() == CCalcul.class)
                        || (pValeur.getClass() == CFonc.class))
                    bufferAffichage.append (((CCalcul)pValeur).chaineCalcul);
                }
                else {
                  String chnombre = new String("");
                  if (st.hasMoreTokens())
                  {
                    String chnbdec = st.nextToken();
                    if (chnbdec.compareTo("+") == 0) {
                      chnombre = pValeur.rendChaineValeurPourCommentaire(2, infoRandom);
                      if (!chnombre.startsWith("-")) chnombre = "+ " + chnombre;
                    }
                    else {
                      Integer nbdec = new Integer(chnbdec);
                      int nbdecimales = nbdec.intValue();
                      chnombre = pValeur.rendChaineValeurPourCommentaire(nbdecimales, infoRandom);
                      if (st.hasMoreTokens())
                      {
                        String chplus = st.nextToken();
                        if (chplus.compareTo("+") == 0)
                        {
                        	if (!chnombre.startsWith("-")) chnombre = "+ " + chnombre;
                        }
                      }
                    }
                  }
                  else
                  {
                    // Si le nombre de dcimales n'est pas prcis, on en met deux par dfaut
                    chnombre = pValeur.rendChaineValeurPourCommentaire(2, infoRandom);
                  }
                  bufferAffichage.append(chnombre);
                }
              }
              j = indparf + 1;
            }
          }
        }
      }		
    }
    if (j < len) bufferAffichage.append(chaineCommentaire.substring(j, len));
    chaineAffichage = bufferAffichage.toString();
    super.positionne(infoRandom, dimfen);
  }
  
  /**
   * Appel par CLatex dans le cas d'uen erreur Latex. dans ce cas l'affichae est remplac par un message d'erreur
   * @param infoRandom
   * @param dimfen
   */
  public void positionnePourCLatex(boolean infoRandom, DimensionFenetre dimfen) {
  	super.positionne(infoRandom, dimfen);
  }
  

  /**
   * Fonction remmplaant les appels dynamiques de la valeur nomme ancienNom par nouveauNom
   * Profondment chng par rapport au C++
   * @param ancienNom
   * @param nouveauNom
   */
  public void remplaceNomValeurDynamique(String ancienNom, String nouveauNom) {
  	String ch1 = "#Val(" + ancienNom + ")";
  	String ch2 = "#Val(" + nouveauNom + ")";
  	chaineCommentaire = chaineCommentaire.replace(ch1, ch2);
  	ch1 = "#For(" + ancienNom + ")";
  	ch2 = "#For(" + nouveauNom + ")";
  	chaineCommentaire = chaineCommentaire.replace(ch1, ch2);
  	ch1 = "#Val(" + ancienNom + ",";
  	ch2 = "#Val(" + nouveauNom + ",";
  	chaineCommentaire = chaineCommentaire.replace(ch1, ch2);
  	ch1 = "#For(" + ancienNom + ",";
  	ch2 = "#For(" + nouveauNom + ",";
  	chaineCommentaire = chaineCommentaire.replace(ch1, ch2);
  }
 
  // Nouveaut pour version 1.8
  public boolean dependDe(CElementBase p) {  
    return super.dependDe(p) || listeValeursDynamiquesUtilisees.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
    return (p == this) || super.dependDePourBoucle(p)
    || listeValeursDynamiquesUtilisees.dependDePourBoucle(p);
  }
  
  @Override
  public long getNature() {
    return NatureObjet.NCommentaire;
  }
    
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    // Modification pour la version 1.9.5 : filtarge des caractres grecs
    chaineCommentaire = Kernel.sansCR(inps.readCStringAvecFiltrage());
    y_nom += Kernel.decalagePourCompatibilite(chaineCommentaire);
    listeValeursDynamiquesUtilisees = new CListeObjets(list.uniteAngle, list.pointeurLongueurUnite);        
    if (list.getClass() != CPrototype.class) determineDependances();
  }
  /* Enregistrement dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    chaineCommentaire = inps.readUTF();
    // y_nom += Glob.decalagePourCompatibilite(chaineCommentaire);
    listeValeursDynamiquesUtilisees = new CListeObjets(list.uniteAngle, list.pointeurLongueurUnite);        
    if (listeProprietaire.getClass() != CPrototype.class) determineDependances();
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeUTF(chaineCommentaire);
  }
}
