/*
 * CConstante.java
 *
 * Created on 1 juillet 2004, 17:23
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;

import types.Complexe;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.Kernel;

public class CConstante extends CCalculBase {
  // La valeur de la constante
	double valeur;

  /** Creates new CConstante */
  public CConstante() {
  }
  
  /** Constructeur avec une valeur initiale */
  public CConstante(CListeObjets liste, double valeurInit)
  {
    super(liste);
    valeur = valeurInit;
  }
  public CCalculBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    return new CConstante(listeCible, valeur);
  }
    
  public double resultat(boolean infoRandom) {
    return valeur;
  }

  // Ajout pour la version 2.0 calculs sur les complexes.
  // Le rsultat est renvoy dans z
  public void resultatComplexe(boolean infoRandom, Complexe zRes) {
    /// Sera redfinie pour tous les descendants pouvant ne pas exister
    zRes.x = valeur;// Par dfaut on suppose le calcul rel
    zRes.y = 0;
  }
  
  @Override
	public String chaineCalcul(String varFor) {
		return Kernel.chaineNombre(valeur, 16);	
	}
	  
  public void chargeDepuisFlux ( MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.chargeDepuisFlux(inps, list);
    valeur = inps.readCDouble();
  }
  /* Enregistrement dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    valeur = inps.readDouble();
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeDouble(valeur);
  }   
  // Ajout pour la version 1.9.5
  // Procdure rcursive servant  savoir si un calcul dpend de la variable formelle
  public boolean  dependDeVariable() {
    return false;
  }
  public CCalculBase getCopie() {
	return new CConstante(listeProprietaire, valeur);
  }
  
  @Override
	public boolean estConstant() {
		return true;
	}
  
   
}
