/*
 * CDroiteAncetre.java
 *
 * Created on 10 juillet 2004, 20:44
 */

/**
 *
 * @author  Yves
 * @version
 */
// Java : Important : en C++ CDemiDroite hritait de CDroite mais appelait la mthode de srialization
// de CElement ligne car il est inutile de mmoriser l'origine et le vecteur
// c'est impossible en java. Une demi-droite ne pouvant pas tre nomme, inutile s'avoir
// un champ abscisseNom
// Mais cela pose un problme car dans la mthode de serialization de CDemiDroiteOA qui hrite de
// CdemiDroite, c'est la mthode de srialization de CDroite qui tait appele, ce qui est illogique.
// Dans chargeDepuisFlux de CDemiDroiteOA, il faut donc dpiler les donnes inutiles
// Mais pourtant une demi-droite doit descendre de l'anctre des droites. J'ai rsolu le problme
// en rajoutant un type CDroiteAncetre qui soit l'anctre de toutes les droites
package objets;

import glob.*;

import java.awt.geom.*;
import java.awt.*;

import types.*;

// Modification pour la version 1.9.5
// A la suite du rajout des lieux d'objets cette classe n'est plus abstract
public class CDroiteAncetre extends CElementLigne {
  private Point2D.Double pointr = new Point2D.Double(); // Pour la rapidit
  public double xext1,yext1;	/// coordonnees d'un des points extremes
  /// affichs  l'cran
  public double xext2,yext2;	/// celles du deuxime
  public double point_x;
  public double point_y;
  public VecteurDirecteur vecteur;
  
  /** Creates new CDroiteAncetre */
  public CDroiteAncetre() {
    vecteur = new VecteurDirecteur();
  }
  
  // Constructeur pour clonage
  public CDroiteAncetre(CListeObjets liste,CImplementationProto impProtoInit,boolean estElementFinalInit,
    Color couleurInit, boolean nomMasqueInit, double dec_xInit, double dec_yInit,
    boolean masqueInit, String nomInit, int indiceTailleNomInit, int styleInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, nomMasqueInit,
      dec_xInit, dec_yInit, masqueInit, nomInit, indiceTailleNomInit, styleInit);
    vecteur = new VecteurDirecteur(); // Pour que lengthvecteur directeur soit cr
  }
  // Constructeur pour les descendants de CdroiteAncetre n'ayant pas besoin d'tre nommes
  public CDroiteAncetre(CListeObjets liste, CImplementationProto impProtoInit,boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, false, 0, 0, masqueInit, "", 0, styleInit);
    vecteur = new VecteurDirecteur();
  }
  
  /** Constructeur pour les descendants de CdroiteAncetre nayant pas besoin d'tre nomms avec un nom ide  */
  public CDroiteAncetre(CListeObjets liste, CImplementationProto impProtoInit,boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit, int indiceTailleNomInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, false, 0, 0, masqueInit, "", 0, styleInit);
    vecteur = new VecteurDirecteur();
  }
  
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    xext1 = ((CDroiteAncetre)ptel).xext1;
    yext1 = ((CDroiteAncetre)ptel).yext1;
    xext2 = ((CDroiteAncetre)ptel).xext2;
    yext2 = ((CDroiteAncetre)ptel).yext2;
    point_x = ((CDroiteAncetre)ptel).point_x;
    point_y = ((CDroiteAncetre)ptel).point_y;
    ((CDroiteAncetre)ptel).vecteur.setCopy(vecteur);
  }
  public boolean appartientA(double x,double y) {
    return existe;
  }
  
  public double abscisseMaximale() {
    // Cas d'un segment ayant ses extrmits confondues
    if ((vecteur.x == 0) && (vecteur.y == 0)) return 0;
    if (Math.abs(vecteur.x) >= Math.abs(vecteur.y))
      return (xext2-point_x)/vecteur.x;
    else
      return (yext2-point_y)/vecteur.y;
  }
  public double abscisseMinimale() {
    // Cas d'un segment ayant ses extrmits confondues
    if ((vecteur.x == 0) && (vecteur.y == 0)) return 0;
    if (Math.abs(vecteur.x) >= Math.abs(vecteur.y))
      return (xext1-point_x)/vecteur.x;
    else
      return (yext1-point_y)/vecteur.y;
  }
  
  /**
   * Procdure utilise pour calculer la distance d'un point  un demi-plan
   * car on dsigne un demi-plan en dsignant la droite qui est
   * son bord et on peut dsigner le demi-plan mme si la droite est cache
   */
	double distancePointPourDemiPlan(double xp,double yp)
	{
		Point2D.Double pointres = new Point2D.Double();
	
		if (!existe) return -1;
		else
		{
			Kernel.projetteOrtho(xp,yp,point_x,point_y,vecteur,pointres);
			return Kernel.distancePointPoint(xp,yp,pointr.x,pointres.y);
		}  //if not(existe)
	}
  
  /** distancePoit renvoie -1 dans le cas o le l'objet n'est pas dsignable */
  public double distancePoint(double xp, double yp, boolean masquage) {
    double dis;
    if (!(existe) || (masquage && masque))
      return -1;
    else {
      Kernel.projetteOrtho(xp,yp,point_x,point_y,vecteur,pointr);
      dis = Kernel.distancePointPoint(xp,yp,pointr.x,pointr.y);
      return dis;
    }
  }
  
  /**
   * Fonction renvoyant true seulement si la droite est visible dans la fentre dimfen
   * @param dimfen
   */
  @Override
  public boolean dansFenetre(DimensionFenetre dimfen) {
    Point2D.Double[] res = new Point2D.Double[4];
    for (int i = 0; i < 4; i++) res[i] = new Point2D.Double();

    Kernel.projetteOrtho(0,0,point_x,point_y,vecteur,res[0]);
    Kernel.projetteOrtho(dimfen.longueurAbscisses,0,point_x,point_y,vecteur,res[1]);
    Kernel.projetteOrtho(0,dimfen.longueurOrdonnees,point_x,point_y,vecteur,res[2]);
    Kernel.projetteOrtho(dimfen.longueurAbscisses,dimfen.longueurOrdonnees,point_x,point_y,vecteur,res[3]);
    boolean resul = false;
    // On regarde si au moins un des 4 projets est dans la toile d'affichage
    for (int i = 0; i < 4; i++)
      resul = resul || dimfen.dansFenetre(res[i].x,res[i].y);
    return resul;
  	
  }
  
  @Override
  public long getNature() {
    return NatureObjet.NDroite;
  }
  
  /** Rajout pour la version 2.0 : permet de connatre si l'lment point par pt
   * est graphiquement (presque) confondu avec l'lment en question ou trs proche.
   * Pour cette version applet, ne sera redfini que pour les objets que l'utilisateur
   * pourra effectivement crer en ligne de faon  tester la validit de la construction.
   **/
  public boolean coincideAvec(CElementBase p) {
    if (p.getNature() != NatureObjet.NDroite) return false;
    CDroiteAncetre dte = (CDroiteAncetre) p;
    VecteurDirecteur vec = new VecteurDirecteur(dte.point_x,dte.point_y, point_x, point_y);
    return (Kernel.colineaires(vecteur, dte.vecteur) && Kernel.colineaires(vec, this.vecteur));
  }
  /**
   * Fonction rajoute pour la version 2.1 et servant  savoir si un point
   * est par dfinition sur une droite. Renverra true par exemple
   * si la droite est dfinie par deux points et le point est un de ces deux points
   * ou si le point est li  la droite
   * A t rajout pour amliorer l'outil d'intersection
   * A redfinir pour les descendants quand ncessaire
   * */
  public boolean contientParDefinition(CPointAncetre po)
  {
    return false;
  }
  
  /**
   * Fonction rajoute par la version 1.2 pour savoir si une droite est prallle  une droite D
   * par dfinition d'aprs les rgles de la gomtrie : par exemple parallle par dfinition
   * ou image de D par une translation, symtrie centrale, homothtie
   * @return
   */
  public boolean estParalleleParDefinition(CDroiteAncetre dte){
  	// return (dte == this) || dte.estParalleleParDefinition(this);
  	return (dte == this);
  }
  
  public boolean estPerpendiculaireParDefinition(CDroiteAncetre dte) {
  	return false;
  }
  
  
	/**
	 * Fonction renvoyant true si pt1 et pt2 forment une droite parallle  this.
	 * Cela arrive quand les deux points sont des points images par une mme translation, homothtie
	 * ou symtrie centrale et quand leurs antcdents sont sur une droite parallle  this
	 * ou quand pt2 est l'image de pt1 par une translation de vecteur dont l'origine et l'extrmit
	 * sont tous les deux sur une droite parallel  D ou vice-versa
	 * @param pt1
	 * @param pt2
	 * @return
	 */
	public boolean formentDroiteParallele(CPointAncetre pt1, CPointAncetre pt2) {
		if (pt1.estPointImage() && pt2.estPointImage()) {
			CPointImage ptim1 = (CPointImage) pt1;
			CPointImage ptim2 = (CPointImage)pt2;
			if ((ptim1.transformation == ptim2.transformation) 
					&&((ptim1.transformation.natureTransformation() & (CTransformation.translation | CTransformation.homothetie | CTransformation.symetrieCentrale)) != 0))
				return listeProprietaire.sontParDefinitionSurParallele(ptim1.antecedent, ptim2.antecedent, this);
			else return false;
		}
		else {
			// On regarde d'abord si pt2 est l'image d'un point de this par une translation  dont l'origine est sur this
			// et l'extrmit est pt1 ou si pt2 est l'image de pt1 par une translation dont le vecteur a son origine et son extrmit
			// qui sont sur this
			if (pt2.estPointImage()) {
				CPointImage ptim = (CPointImage) pt2;
				if (ptim.transformation.natureTransformation() == CTransformation.translation) {
					CTranslation trans = (CTranslation) ptim.transformation;
					return ((trans.extremiteVecteur == pt1) && (trans.origineVecteur.appartientParDefinition(this) && ptim.antecedent.appartientParDefinition(this)))
							|| (ptim.antecedent == pt1) && listeProprietaire.sontParDefinitionSurParallele(trans.origineVecteur, trans.extremiteVecteur, this);
				}	
				else return false;
			}
			// On regarde ensuite si pt1 est l'image d'un point de this par une translation  dont l'origine est sur this
			// et l'extrmit est pt2 ou si pt1 est l'image de pt2 par une translation dont le vecteur a son origine et son extrmit
			// qui sont sur this
			if (pt1.estPointImage()) {
				CPointImage ptim = (CPointImage) pt1;
				if (ptim.transformation.natureTransformation() == CTransformation.translation) {
					CTranslation trans = (CTranslation) ptim.transformation;
					return ((trans.extremiteVecteur == pt2) && (trans.origineVecteur.appartientParDefinition(this) && ptim.antecedent.appartientParDefinition(this)))
							|| (ptim.antecedent == pt2) && listeProprietaire.sontParDefinitionSurParallele(trans.origineVecteur, trans.extremiteVecteur, this);
				}
				else return false;
			}
			else return false;
		}
	}
}

