/*
 * CFonc.java
 *
 * Created on 6 juillet 2004, 20:52
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CFonc extends CCalcul {
	public String chaineVariable;

  /** Creates new CFonc */
  public CFonc() {
  }
  
  /* Constructeur pour outil de cration */
  public CFonc(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit) {
    super(liste, impProtoInit, estElementFinalInit);
  }
  
  // Constructeur pour clonage
  public CFonc(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      String nomInit,String chaineCalculInit,
      CCalculBase calculInit, String chaineVariableInit) {
    super(liste, impProtoInit, estElementFinalInit, nomInit, chaineCalculInit, calculInit);
    chaineVariable = new String(chaineVariableInit);
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(impProto);        
    CCalculBase calculClone = calcul.getClone(listeSource, listeCible);
    CElementBase ptelb = new CFonc(listeCible, (CImplementationProto)(listeCible.get(ind1, CImplementationProto.class)),
      estElementFinal, nomCalcul, chaineCalcul, calculClone, chaineVariable);
    return ptelb;    
  }

  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NFonction;
  }
  
  /***
   * Fonction reconstruisant la chaine reprsentant le calcul (par exemple lorsqu'un autre calcul a t renomm
   * A redfinir pour les fonctions
   */
  public void reconstruitChaineCalcul() {
  	chaineCalcul = calcul.chaineCalculSansPar(chaineVariable);	
  }
  
  /**
   * Fonction renvoyant une chaine du type f(t) = .... pour certain champs de botes de dialogues
   * @return
   */
  public String infoFormule() {
  	return nom() + "(" + chaineVariable + ")" + " = " + chaineCalcul;
  }
  
   // Inutile de redfinir informationModification() pour les objets de type calcul    
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    chaineVariable = inps.readCString();
  }

  // Version 1.9.5 : Suite  l'introduction de CDerivee
  // il a fallu dfinir cette produre car CDerivee n'enregistre
  // pas le calcul dans le flux.
   public void chargeDepuisFluxSansCalcul(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFluxSansCalcul(inps,list);
  }
 
  /* Lecture depuis un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    chaineVariable = inps.readUTF();
  }
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeUTF(chaineVariable);
  }
  /* Lecture depuis un flux java pour lecture de drive */  
  public void readSansCalcul(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.readSansCalcul(inps, list);
  }  
  /* Enregistrement dans un flux java */
  public void writeSansCalcul(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.writeSansCalcul(oups, list);
  }

  public double rendValeurFonction(boolean infoRandom, double parametre)
    throws ErreurCalculException {
      return calcul.resultatFonction(infoRandom, parametre);
  }

  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = calcul.existe();
  }  
  
  /**
   * Pour savoir si le calcul est une fonction relle, une suite relle ou non
   * Redfini seulement pour CFonc, CFoncComplexe, CSuiteRec et CSuiteRecComplexe;
   */ 
  public boolean estFonctionOuSuite() {
    return true;
  }
  
  
}

