/*
 * CGrandArcDeCercle.java
 *
 * Created on 9 juillet 2004, 11:19
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;
import glob.*;

import java.awt.*;

import types.*;

public class CGrandArcDeCercle extends CArcDeCercle {
  
  /** Creates new CGrandArcDeCercle */
  public CGrandArcDeCercle() {
  }
  
  // Constructeur pour clonage
  public CGrandArcDeCercle(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit,
    CPointAncetre OInit, CPointAncetre AInit, CPointAncetre pointFinArcInit,
    CValeurAngle angleAuCentreInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit, OInit, AInit,
      pointFinArcInit, angleAuCentreInit);
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(O);
    int ind2 = listeSource.indexOf(A);
    CPointAncetre ptFinArc = null;
    CValeurAngle angleAuCentreClone = null;
    if (pointFinArc == null)
      angleAuCentreClone = (CValeurAngle) angleAuCentre.getClone(listeSource, listeCible);
    else {
      int ind3 = listeSource.indexOf(pointFinArc);
      ptFinArc = (CPointAncetre)(listeCible.get(ind3, CPointAncetre.class));
    }
    int ind4 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CGrandArcDeCercle(listeCible, (CImplementationProto)(listeCible.get(ind4, CImplementationProto.class)),
      estElementFinal, couleur, masque, style, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)),
      (CPointAncetre)(listeCible.get(ind2, CPointAncetre.class)), ptFinArc, angleAuCentreClone);
    return ptelb;
  }
  
  // Modifi pour la version 1.9.5 car surArc ne doit plus utiliser de pointeurs
  // sur les objets sources
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
    int styleTrait;
    if (masque) styleTrait = StyleTrait.traitPointille;
    else styleTrait = style;
    // Rajout en java par rapport  la version C++
    if (Kernel.testToile(centre_x, centre_y) && Kernel.testToile(origine_x, origine_y)) {
      pDC.setStroke(Pinceau.CreePinceau(styleTrait));
      pDC.setColor(couleur);
      Kernel.secteurRentrant(pDC, origine_x, origine_y, centre_x, centre_y, rayon, valeurAngleAuCentre);
    }
  }
  
  public boolean surArc(double xt, double yt) {
    double ang,ang1aux,ang2aux,dif;
    
    VecteurDirecteur w = new VecteurDirecteur(centre_x, centre_y, xt, yt);
    ang = w.angleRad();
    ang1aux = ang1;
    ang2aux = ang2;
    // On ordonne ang1Aux et ang2Aux dans l'ordre croissant
    if (ang1aux > ang2aux) {
      double d = ang2aux;
      ang2aux = ang1aux;
      ang1aux = d;
    }
    dif = ang2aux - ang1aux;
    if (Kernel.zeroAngle(dif - Math.PI)) {
      if (ang1 >= ang2) {
        return ((ang >= ang2) && (ang <= ang1));
      } else {
        return ((ang >= ang2) || (ang <= ang1));
      }
    } else {
      if (dif < Math.PI) {
        return ((ang <= ang1aux) || (ang >= ang2aux));
      } else {
        return ((ang >= ang1aux) && (ang <= ang2aux));
      }
    }
  }
  
  public double abscisseCurviligne(double ang) {
    double difang;
    
    if (valeurAngleAuCentre == 0) return 0;
    if (valeurAngleAuCentre >= 0) {
      if (ang <= ang1)
        difang = ang1 - ang;
      else difang = 2*Math.PI - ang + ang1;
    } else {
      if (ang >= ang1) difang = ang - ang1;
      else difang = 2*Math.PI - ang1 + ang;
    }
    return difang/(2*Math.PI-Math.abs(valeurAngleAuCentre));
  }
  
  
  // Mthode dfinie pour la version 1.8
  public int natureArc() {
    return NatureArc.NatureArcGrandArc;
  }
  
}
