/*
 * CImage.java
 *
 * Created on 21 fvrier 2005, 18:55
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.*;
import java.io.*;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CImage extends CAffichageLieAPoint {
  public Image image; // l'image. Celle-ci est charge avec les uatres images lors
  // de la serialization du document.
	public String imagePath;  // Le chemin d'accs relatif au fichier
	// String absolutePath; // Le chemin total d'accs. Ne sera utilis que quand
	// on dite une figure incorpore dans un document ( supposer que la figure
	// n'ait pas t dplace ... Ne sert pas en java

  /** Creates new CImage */
  public CImage() {
  }

  public CImage(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit,
      double dec_yInit, boolean masqueInit, CPointAncetre pointLieInit, int indiceTaillePoliceInit,
      int encadrementInit, boolean effacementFondInit, Color couleurFondInit, String imagePathInit) {
    super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
      dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit, encadrementInit,
      effacementFondInit, couleurFondInit);
    imagePath = imagePathInit;
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointLie);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CImage(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y,
      masque, (CPointAncetre)listeCible.get(ind1, CPointAncetre.class), indiceTaillePolice, encadrement,
      effacementFond, couleurFondAffichage, imagePath);
    ((CImage)ptelb).image = image;
    return ptelb;
  }

  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    super.positionne(infoRandom, dimfen);
    if (! existe) return;
    rectangleAffichage.x = (int) (x_nom + dec_x);
    rectangleAffichage.y = (int) (y_nom + dec_y);

    xEncadrement = rectangleAffichage.x;
    yEncadrement = rectangleAffichage.y;
    widthEncadrement = rectangleAffichage.width;
    heightEncadrement = rectangleAffichage.height;
 
    switch (encadrement) {
	    case StyleEncadrement.Simple :
	      xEncadrement -= 1;
	      yEncadrement -= 1;
	      widthEncadrement += 2;
	      heightEncadrement += 2;
	      break;
	    case StyleEncadrement.Effet3D :
	      xEncadrement -= 1;
	      yEncadrement -= 1;
	      widthEncadrement += 3;
	      heightEncadrement += 3;
    }
  }  
 
  @Override
  public void affiche(Graphics2D pDC, boolean masquage,  Color couleurFond, float transparence) {
    if (!masque) trace(pDC, couleurFond, transparence);
  }
  
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
    if (effacementFond)
    {
      //Affichage avec effacement du fond
      // pDC.setColor(couleurFond);
      pDC.fillRect(rectangleAffichage.x, rectangleAffichage.y, rectangleAffichage.width,
      		rectangleAffichage.height);
      pDC.drawImage(image,rectangleAffichage.x, rectangleAffichage.y, rectangleAffichage.width,
        rectangleAffichage.height, couleurFond, null);
    }
    else
    {
      pDC.drawImage(image,rectangleAffichage.x, rectangleAffichage.y, rectangleAffichage.width,
        rectangleAffichage.height, null);
    }
    if (encadrement != 0)  //  revoir
    {
      pDC.setColor(couleur);
      pDC.drawRect(xEncadrement, yEncadrement, rectangleAffichage.width + 1, rectangleAffichage.height + 1);
    }
    if (encadrement == StyleEncadrement.Effet3D) {
      int x1 = xEncadrement + rectangleAffichage.width + 2;
      int y1 = yEncadrement + rectangleAffichage.height + 2;
      pDC.drawLine(xEncadrement + 1, y1, x1, y1);
      pDC.drawLine(x1, yEncadrement + 1, x1, y1);
    }
    
  }

  // Doit tre redfinie car est de base Abstrac mais ne sert pas pour les images
  protected String rendChaineAffichage(boolean infoRandom) {
    return "";
  }
  
  @Override
  public boolean confonduAvec(CElementBase p) {
    CImage pt;
    if (p.getClass() == this.getClass()) {
      pt = (CImage) p;
      return (imagePath == pt.imagePath);
    }
    else return false;
  }  
  
  @Override
  public long getNature() {
    return NatureObjet.NImage;
  }
  
 	/**
 	 * Adaptation de certains objets pour passer en haute rsolution avant
 	 * impression notamment
 	 */
   @Override
 	public void adaptePourHauteResolution() {
  	super.adaptePourHauteResolution();
 		rectangleAffichage.width *= 10;
 		rectangleAffichage.height *= 10;
 	}
   
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    imagePath = inps.readCString();
    @SuppressWarnings("unused")
		String absolutePath = inps.readCString();
    rectangleAffichage.width = inps.readCInt()/10;
    rectangleAffichage.height = inps.readCInt()/10;
  }
  
  /* Enregistrement dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    // Il faut quand mme entregistrer dans le flux les dimensions de l'image
    // car l'applet en a besoin (alors que le programme java non)
    rectangleAffichage.width = inps.readInt();
    rectangleAffichage.height = inps.readInt();
    imagePath = inps.readUTF();
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeInt(rectangleAffichage.width);
    oups.writeInt(rectangleAffichage.height);
    oups.writeUTF(imagePath);
  }    
}
