/*
 * CLieuObjetParVariable.java
 *
 * Created on 14 juillet 2004, 18:04
 */

/**
 *
 * @author  Yves
 * @version
 */
package objets;

import java.io.*;
import java.awt.Color;
import types.DimensionFenetre;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;


public class CLieuObjetParVariable extends CLieuObjetAncetre {
  CVariableBornee  variableGeneratrice;
  
  /**
   * Creates new CLieuObjetParVariable
   */
  public CLieuObjetParVariable() {
  }
  
  // Constructeur pour clonage
  public CLieuObjetParVariable(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, CElementGraphique elementAssocieInit, CValeurAssocieeAVariable nombreTracesInit,
    CVariableBornee variableGeneratriceInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit,
      masqueInit, elementAssocieInit,  nombreTracesInit);
    variableGeneratrice = variableGeneratriceInit;
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(elementAssocie);
    int ind2 = listeSource.indexOf(variableGeneratrice);
    int ind3 = listeSource.indexOf(impProto);
    CValeurAssocieeAVariable nombreTracesClone = (CValeurAssocieeAVariable) nombreTraces.getClone(listeSource, listeCible);
    CElementBase ptelb = new CLieuObjetParVariable(listeCible, (CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, masque, (CElementGraphique)(listeCible.get(ind1, CElementGraphique.class)), nombreTracesClone,
      (CVariableBornee)(listeCible.get(ind2)));
    if (listeCible.getClass() != CPrototype.class) {    
	    ((CLieuObjetParVariable)ptelb).listeElementsAncetres.setImage(listeElementsAncetres, listeProprietaire,
	      ptelb.listeProprietaire);
	    // La ligne suivante ne doit pas tre appele quand on implmente un prototype. Cela sera fait par metAJour()
      // Comme le nombre d'objets est dynamique on ne peut pas savoir au chargement combien il y en a.
	    // if (listeSource.getClass() != CPrototype.class) ((CLieuObjetParVariable)ptelb).listeCopiesObjet.ajouteClonesDe
	    //	(((CLieuObjetParVariable)ptelb).elementAssocie, listeCopiesObjet.size());
    }
    return ptelb;
  }
  
  @Override
  public void metAJour() {
  	super.metAJour();
  	etablitListeElementsAncetres();
  	listeCopiesObjet.retireTout();
    listeCopiesObjet.ajouteClonesDe(elementAssocie, (int) nombreTraces.rendValeur(false));
    donneCouleur(couleur); // Pour que les lments clons aient la couleur du lieu d'objets
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    double valeur, valeurMinimale, valeurMaximale, valeurInitiale, pas;
    super.positionne(infoRandom, dimfen);
    existe = existe && (nombreObjetsPourLieuObjet() <= nombreMaxiPourLieuObjet);
    double dnbt = Math.round(nombreTraces.rendValeur(false));
    existe = existe && (dnbt>=2) && (dnbt<=nombreMaxiPourLieuObjet);
    if (!existe) return;
    int nbt = (int) dnbt;
    // Changement important de la version 2.5, le nombre de traces tant devenu dynamique
    if (nbt != listeCopiesObjet.size()) ajusteListeCopieObjets();
    valeurMinimale = variableGeneratrice.valeurMini;
    valeurMaximale = variableGeneratrice.valeurMaxi;
    valeurInitiale = variableGeneratrice.valeurActuelle;
    // Pour tenir compte des points lis lis  des lieux ferms
    pas = (valeurMaximale-valeurMinimale)/(nbt - 1);
    valeur = valeurMinimale - pas;
    
    boolean elementAssocieMasque = elementAssocie.masque;
    elementAssocie.montre();
    existe = false;
    for (int i = 0; i < nbt; i++) {
      valeur = valeur + pas;
      variableGeneratrice.donneValeur(valeur);
      listeElementsAncetres.positionne(infoRandom, dimfen);
      existe = existe || elementAssocie.existe;
      CElementGraphique ptelg = (CElementGraphique)listeCopiesObjet.get(i);
      ptelg.setClone(elementAssocie);
      // Au cas o l'objet gnrateur du lieu serait ferm
      ptelg.montre();
    }
    elementAssocie.masque = elementAssocieMasque;
    // On redonne  la variable gnratrice sa valeur initiale
    variableGeneratrice.donneValeur(valeurInitiale);
    listeElementsAncetres.positionne(infoRandom, dimfen);
  }
  
  @Override
  public boolean confonduAvec(CElementBase p) {
    CLieuObjetParVariable pt;
    if (p.getClass() == this.getClass()) {
      pt = (CLieuObjetParVariable) p;
  		return (variableGeneratrice == pt.variableGeneratrice)
			&& (elementAssocie == pt.elementAssocie)
			&& nombreTraces.confonduAvec(pt.nombreTraces);    
		}
    else return false;
  }  
  
  public void etablitListeElementsAncetres() {
    int indicePointATracer = listeProprietaire.indexOf(elementAssocie);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    listeElementsAncetres.retireTout();
    if (listeProprietaire.getClass() != CPrototype.class) {
      for (int i = 0; i <= indicePointATracer; i++) {
        CElementBase ptelb = (CElementBase)(listeProprietaire.get(i));
        if ((elementAssocie.dependDe(ptelb)) && (ptelb.dependDe(variableGeneratrice)))
          listeElementsAncetres.add(ptelb);
      }
    }	
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    if (nVersion == 1) {
    	super.chargeDepuisFlux(inps, list);
      nVersion = numeroVersion(); // On remet tout  zro pour la version java
    }
    else super.chargeDepuisFluxNew(inps, list);
    int ind1 = inps.readCInt();
    variableGeneratrice = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Version 1.9.5 : modifi pour optimisation
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      int indiceElementAssocie = list.indexOf(elementAssocie);
      for (int i = 0; i <= indiceElementAssocie; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((elementAssocie.dependDe(ptelb)) && (ptelb.dependDe(variableGeneratrice)))
          listeElementsAncetres.add(ptelb);
      }
    }
    nVersion = numeroVersion(); // On remet tout  zro pour la version java
  }
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    variableGeneratrice = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    // Il faut prparer la liste des lments dont dpend le point  tracer
    // Version 1.9.5 : modifi pour optimisation
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      int indiceElementAssocie = list.indexOf(elementAssocie);
      for (int i = 0; i <= indiceElementAssocie; i++) {
        CElementBase ptelb = (CElementBase)(list.get(i));
        if ((elementAssocie.dependDe(ptelb)) && (ptelb.dependDe(variableGeneratrice)))
          listeElementsAncetres.add(ptelb);
      }
    }
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(variableGeneratrice);
    oups.writeInt(ind1);
  }
}
