/*
 * CLigneBrisee.java
 *
 * Created on 16 juillet 2004, 11:50
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.util.*;

import java.awt.Color;

import types.*;

public class CLigneBrisee extends CLignePolygonaleAncetre {

  /** Creates new CLigneBrisee */
  public CLigneBrisee() {
  	super();
  }
  
  /**
   * Constructeur pour construction d'objet graphique
   * @param couleurInit
   * @param styleInit
   */
  public CLigneBrisee(CListeObjets liste, Color couleurInit, int styleInit) {
  	super(liste, couleurInit, styleInit);
  }
  
  /** Construction  partir d'un vecteur de CNoeudPointeurSurPoint */
  public CLigneBrisee(CListeObjets liste, Vector<CNoeudPointeurSurPoint> vecteur, Color couleurInit, int styleInit) {
  	super(liste, vecteur, couleurInit, styleInit);
  }
  
  
  // Constructeur pour clonage
  public CLigneBrisee(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit, Vector<CNoeudPointeurSurPoint> collectionPointsInit) {
    super (liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit, collectionPointsInit);
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    Vector<CNoeudPointeurSurPoint> colClone = new Vector<CNoeudPointeurSurPoint>();
    ListIterator<CNoeudPointeurSurPoint> li = collectionPoints.listIterator();
    while(li.hasNext()) {
      CNoeudPointeurSurPoint noeud = (CNoeudPointeurSurPoint) (li.next());
      CNoeudPointeurSurPoint noeudClone = noeud.getClone(listeSource, listeCible);
      colClone.add(noeudClone);
    }
    int ind1 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CLigneBrisee(listeCible, (CImplementationProto)(listeCible.get(ind1, CImplementationProto.class)),
      estElementFinal, couleur, masque, style, colClone);
    return ptelb;    
  }
  
  public double abscisseMaximale() {
    return 1;
  }

  public double abscisseMinimale() {
    return 0;
  }
 
  @Override
  public long getNature() {
    return NatureObjet.NLigneBrisee;
  }

  @Override
  public String complementInfo() {
    return textes.Chaines.chinfo46;
  }
  
  public boolean confonduAvec(CElementBase p) {
    CLigneBrisee pt;
  	CPointAncetre ptp1;
  	CPointAncetre ptp2;

    if (p.getClass() != CLigneBrisee.class) return false;
  	
  	pt= (CLigneBrisee) p;

  	int nombrePoints = collectionPoints.size();
  	if (nombrePoints != pt.collectionPoints.size()) return false;
  	// On regarde si une ligne brise forme des mmes points
  	// a dj t cre dans le mme sens
  	boolean confondu = true;
  	for (int i = 0; i < nombrePoints; i++) {
  		ptp1 = collectionPoints.get(i).pointeurSurPoint;
  		ptp2 = pt.collectionPoints.get(i).pointeurSurPoint;
  		confondu = confondu && (ptp1 == ptp2);
  	}
  	// ou dans le sens inverse
  	if (! confondu)
  	{
  		confondu = true;
    	for (int i = 0; i < nombrePoints; i++) {
    		ptp1 = collectionPoints.get(i).pointeurSurPoint;
    		ptp2 = pt.collectionPoints.get(nombrePoints-i-1).pointeurSurPoint;
    		confondu = confondu && (ptp1 == ptp2);
    	}
  	}
  	return confondu;  	
  }
  
  
}
