/*
 * CMacroAffectationPointLie.java
 *
 * Created on 23 aot 2004, 16:31
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;
import java.awt.Color;
import Applet.AppletMathGraph32;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CMacroAffectationPointLie extends CMacro {
	public CPointLie pointLieAPositionner;
	public CPointLie pointLieAssocie;

  /** Creates new CMacroAffectationPointLie */
  public CMacroAffectationPointLie() {
  }
  
  // Constructeur pour clonage
  public CMacroAffectationPointLie(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit,
      String commentaireMacroInit, CPointLie pointLieAPositionnerInit, CPointLie pointLieAssocieInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit,
          effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit);
       pointLieAPositionner = pointLieAPositionnerInit;
       pointLieAssocie = pointLieAssocieInit;
  }
 
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointLieAPositionner);
    int ind2 = listeSource.indexOf(pointLieAssocie);
    int ind3 = listeSource.indexOf(pointLie);
    int ind4 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CMacroAffectationPointLie(listeCible, (CImplementationProto)(listeCible.get(ind4, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind3, CPointAncetre.class), indiceTaillePolice,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro, (CPointLie)(listeCible.get(ind1, CPointLie.class)),
      (CPointLie)(listeCible.get(ind2, CPointLie.class)));
    return ptelb;
  } 

  @Override
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || pointLieAPositionner.dependDe(p) || pointLieAssocie.dependDe(p);
  }
  
  @Override
  public boolean dependDePourBoucle(CElementBase p) {
    return (super.dependDePourBoucle(p) || pointLieAPositionner.dependDePourBoucle(p)
      || pointLieAssocie.dependDePourBoucle(p));
  }

  @Override
  public boolean executionPossible() {
    return pointLieAPositionner.existe && pointLieAssocie.existe;
  }

  @Override
  public void actionDansPaint(AppletMathGraph32 applet) {
  	// Modifications version 2.0
  	/*
  	MtgPaneFigure paneFigure = applet.paneFigure;
    boolean infr = applet.infRand;
    DimensionFenetre dimfen = applet.dimf;
    pointLieAPositionner.donneAbscisse(pointLieAssocie.abscisse);
    applet.listePr.effaceTout(paneFigure.gbuffer, dimfen, true);
    listeProprietaire.positionne(infr, dimfen);
    paneFigure.afficheToutDansgbuffer();   
    executionEnCours = false;
    */
    pointLieAPositionner.donneAbscisse(pointLieAssocie.abscisse);
    applet.redessine();
    executionEnCours = false;
  }
  
  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
  	if (pointLieAssocie == ancienPoint) pointLieAssocie = (CPointLie) nouveauPoint;
  	if (pointLieAPositionner == ancienPoint) pointLieAPositionner = (CPointLie) nouveauPoint;
  }
      
  @Override
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    pointLieAPositionner = (CPointLie) (list.get(ind1,CPointLie.class));
    int ind2 = inps.readCInt();
    pointLieAssocie = (CPointLie) (list.get(ind2,CPointLie.class));
  }
  /* Lecture depuis dans un flux java */  
  @Override
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    pointLieAPositionner = (CPointLie) (list.get(ind1,CPointLie.class));
    int ind2 = inps.readInt();
    pointLieAssocie = (CPointLie) (list.get(ind2,CPointLie.class));
  }  
  /* Enregistrement dans un flux java */
  @Override
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(pointLieAPositionner);
    oups.writeInt(ind1);
    int ind2 = list.indexOf(pointLieAssocie);
    oups.writeInt(ind2);
  }
}
