/*
 * CMacroAffectationValeurVariable.java
 *
 * Created on 18 aot 2004, 17:51
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

// Java :  noter que le fonctionnement de cette macro est amlior par rapport au C++ avec
// l'utilisation d'une liste d'objets sur les lements dpendant de la variable modifie
import java.io.*;
import java.awt.Color;
import Applet.AppletMathGraph32;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CMacroAffectationValeurVariable extends CMacro {
	public CValeurAssocieeAVariable valeurAssociee;
  public CVariableBornee variableAssociee;
  private CListeObjets listeDep;
  /** Creates new CMacroAffectationValeurVariable */
  public CMacroAffectationValeurVariable() {
  }
  
  // Constructeur pour clonage
  public CMacroAffectationValeurVariable(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
      CValeurAssocieeAVariable valeurAssocieeInit, CVariableBornee variableAssocieeInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit,
          effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit);
        valeurAssociee = valeurAssocieeInit;
        variableAssociee = variableAssocieeInit;
        // Il faut crer la liste des lments dpendant de la variable
        listeDep = new CListeObjets();    
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CValeurAssocieeAVariable valeurClone = (CValeurAssocieeAVariable) valeurAssociee.getClone(listeSource, listeCible);
    int ind1 = listeSource.indexOf(variableAssociee);
    int ind2 = listeSource.indexOf(pointLie);
    int ind3 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CMacroAffectationValeurVariable(listeCible,
    	(CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind2, CPointAncetre.class), indiceTaillePolice,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro, valeurClone,
      (CVariableBornee)(listeCible.get(ind1, CVariableBornee.class)));
    listeDep.initialise(listeCible.uniteAngle, listeCible.pointeurLongueurUnite);
    // On ne peut pas  ce niveau faire une image de la liste ListeDep dans la liste clone car tous
    // les lments n'ont pas encor t chargs.
    //((CMacroAffectationValeurVariable)ptelb).listeDep.setImage(listeDep, listeProprietaire,
    //  ptelb.listeProprietaire);
    return ptelb;
  }

  
  @Override
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || variableAssociee.dependDe(p) || valeurAssociee.dependDe(p);
  }

  @Override
  public boolean dependDePourBoucle(CElementBase p) {
    return super.dependDePourBoucle(p) || variableAssociee.dependDePourBoucle(p)
      || valeurAssociee.dependDePourBoucle(p);
  }

  // Ajout pour version 3.0
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
  	super.positionne(infoRandom, dimfen);
  	valeurAssociee.positionne(infoRandom, dimfen);
  	existe = existe && valeurAssociee.existe();
  }
  
  @Override
  public boolean agitSurVariable(CVariableBornee var) {
  	return (var == variableAssociee);
  }
  
  @Override
  public boolean affecteValeurAVariable(CValeurDynamique val) {
  	return valeurAssociee.calcul.dependDe(val);
  }  

  @Override
  public void actionDansPaint(AppletMathGraph32 applet) {
  	// A revoir pour l'applet
  	// Important : ligne suivante ncessaire pour la version 3.0 (changement de CValeurDynamique)
  	valeurAssociee.positionne(applet.infRand, applet.dimf);
    boolean infor = applet.infRand;
    DimensionFenetre dimfen = applet.dimf;
    double resultatValeur = valeurAssociee.rendValeur(infor);
    // Modification version 2.0
    // listeDep.effaceTout(applet.paneFigure.gbuffer, dimfen, true);
    variableAssociee.donneValeur(resultatValeur);
    listeDep.positionne(infor, dimfen);
    applet.paneFigure.afficheToutDansgbuffer();
  	// applet.metAJourDialogueAffichageVariables(variableAssociee);
  	// frame.cadreActif().redessine();
    // Modifi version 1.8
    executionEnCours = false;
  }

  @Override
  public void executeSimple(AppletMathGraph32 applet) {
  	// A revoir pour l'applet
  	// Important : ligne suivante ncessaire pour la version 3.0 (changement de CValeurDynamique)
  	valeurAssociee.positionne(applet.infRand, applet.dimf);
    executionEnCours = false;
    double resultatValeur = valeurAssociee.rendValeur(applet.infRand);
    variableAssociee.donneValeur(resultatValeur);
    // Ligne suivante supprime version 2.4.0
    // listeDep.positionne(applet.infRand, applet.dimf);
  }
  

  /** Mthode charge de remettre la figure en tat initial
   * et n'existant pas dans l'applet. Charge de mettre  jour
   * le dialogue ventuel d'affichage des variables en bas  droite
   */
  /*
  public void termineAction(AppletMathGraph32 applet) {
    super.termineAction(applet);
    applet.metAJourDialogueAffichageVariables(variableAssociee);
  }
  */
  
  @Override
  public boolean executionPossible() {
    boolean resultat = valeurAssociee.existe() && variableAssociee.existe;
    if (resultat)
    {
      boolean infr = false; // Pas de recalcul alatoire
      double nouvelleValeur = valeurAssociee.rendValeur(infr);
      resultat = (nouvelleValeur >= variableAssociee.valeurMini)
        && (nouvelleValeur <= variableAssociee.valeurMaxi);
    }
    return resultat;
  }
    
  @Override
  public void etablitListesInternes() {
    listeDep = new CListeObjets(listeProprietaire.uniteAngle, listeProprietaire.pointeurLongueurUnite);        
    listeDep.ajouteObjetsDependantsSauf(variableAssociee, listeProprietaire, this);
  }
       
  @Override
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    valeurAssociee = new CValeurAssocieeAVariable();
    valeurAssociee.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    variableAssociee = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    // Il faut crer la liste des lments dpendant de la variable modifie
    // Pour cette liste, on fait pointer la longueur unit ventuelle sur la liste mre
    listeDep = new CListeObjets(list.uniteAngle, list.pointeurLongueurUnite);
  }
  /* Lecture depuis dans un flux java */  
  @Override
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    valeurAssociee = new CValeurAssocieeAVariable();
    valeurAssociee.read(inps, list);
    int ind1 = inps.readInt();
    variableAssociee = (CVariableBornee) (list.get(ind1,CVariableBornee.class));
    // Il faut crer la liste des lments dpendant de la variable modifie
    // Pour cette liste, on fait pointer la longueur unit ventuelle sur la liste mre
    listeDep = new CListeObjets(list.uniteAngle, list.pointeurLongueurUnite);
  }  
  /* Enregistrement dans un flux java */
  @Override
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    valeurAssociee.write(oups, list);
    int ind1 = list.indexOf(variableAssociee);
    oups.writeInt(ind1);
  }
}
