/*
 * CMacroAnimationAvecTrace.java
 *
 * Created on 22 fvrier 2005, 11:36
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;
import java.awt.Color;
import Applet.AppletMathGraph32;
import Applet.MtgPaneFigure;
import types.*;
import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;
import glob.*;
/**
 * Dans la version logiciel java, listeDep est un membre dont les lments sont initialiss  la fin
 * du chargement d'une liste ou lors du clonage pour permettre le multitche.
 * @author Yves
 *
 */
public class CMacroAnimationAvecTrace extends CMacroAvecListe {
  public CPointLie pointLieAssocie;
	public boolean unSeulCycle;
	public boolean effacementFinCycle;
	public boolean animationCyclique;
  public int frequenceAnimationMacro;
  public int nombrePointsPourAnimation;
	public int dureeAnimation; // Dure en secondes (0 si animation
											// jusqu' clic de souris)
	private CListeObjets listeDep;
  private double abscisseInitiale;
  private double abscisse; // l'abscisse en cours du point li qui bouge
  private double abscisseMini;
  private double abscisseMaxi;
  private double pas;
  // Membre n'existant pas dans la version C++ : sert  savoir si on est arriv
  // en fin de boucle et s'il faut effacer les traces 
  boolean effacementTraces;

  /** Creates new CMacroAnimationAvecTrace */
  public CMacroAnimationAvecTrace() {
  }

  // Constructeur pour clonage
  public CMacroAnimationAvecTrace(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit,boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
      CSousListeObjets listeAssocieeInit, CPointLie pointLieAssocieInit, boolean unSeulCycleInit,
      boolean effacementFinCycleInit, boolean animationCycliqueInit,int frequenceAnimationMacroInit,
      int nombrePointsPourAnimationInit, int dureeAnimationInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit, encadrementInit,
          effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit, listeAssocieeInit);
    pointLieAssocie = pointLieAssocieInit;
    unSeulCycle = unSeulCycleInit;
    effacementFinCycle = effacementFinCycleInit;
    animationCyclique = animationCycliqueInit;
    frequenceAnimationMacro = frequenceAnimationMacroInit;
    nombrePointsPourAnimation = nombrePointsPourAnimationInit;
    dureeAnimation = dureeAnimationInit; // Dure en secondes (0 si animation
    listeDep = new CListeObjets(liste);
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    CSousListeObjets listeAssocieeClone = new CSousListeObjets();
    listeAssocieeClone.setImage(listeAssociee, listeSource, listeCible);
    int ind1 = listeSource.indexOf(pointLieAssocie);    
    int ind2 = listeSource.indexOf(pointLie);
    int ind3 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CMacroAnimationAvecTrace(listeCible,
    		(CImplementationProto)(listeCible.get(ind3, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind2, CPointAncetre.class), indiceTaillePolice, 
      encadrement, effacementFond, couleurFondAffichage, intitule, commentaireMacro, listeAssocieeClone,
      (CPointLie) (listeCible.get(ind1, CPointLie.class)), unSeulCycle , effacementFinCycle,
      animationCyclique, frequenceAnimationMacro , nombrePointsPourAnimation,
      dureeAnimation);
    ((CMacroAnimationAvecTrace)ptelb).listeDep = new CListeObjets(listeCible);
    return ptelb;
  }  
  
  @Override
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || pointLieAssocie.dependDe(p);
  }
  
  @Override
  public boolean dependDePourBoucle(CElementBase p) {
    return super.dependDePourBoucle(p) || pointLieAssocie.dependDePourBoucle(p);
  }

  @Override
  public int typeAnimation() {
    return CMacro.animationParTimer;
  }
  
  @Override
  public int frequenceAnimation() {
    return frequenceAnimationMacro;
  }
  
  @Override
  public long dureePourAnimation() {
    return dureeAnimation;
  }
  
  @Override
  public boolean arretParClic() {
  	return (dureeAnimation == 0);
  }
  
  @Override
  public void metAJour() {
  	super.metAJour();
  	etablitListesInternes();
  }
  
  /**
   * Fonction prparant les listes dont la macro a besoin pour s'excuter
   */
  @Override
  public void etablitListesInternes() {
  	listeDep.retireTout();
    listeDep.ajouteObjetsDependantsSauf(pointLieAssocie, listeProprietaire, this);
  }
  
  
  @Override
  public void actionAvantExecution(AppletMathGraph32 applet) {
  	super.actionAvantExecution(applet);  // Met executionEnCours  true
    // Rajout pour version 1.8
    applet.initilizetbuffer();   
    // On mmorise la position actuelle du point li
    abscisseInitiale = pointLieAssocie.abscisse;
    abscisseMini = pointLieAssocie.abscisseMinimale();
    abscisseMaxi = pointLieAssocie.abscisseMaximale();
    if (abscisseMini > abscisseMaxi) {
      double d = abscisseMini;
      abscisseMini = abscisseMaxi;
      abscisseMaxi = d;
    }
    
    if (pointLieAssocie.lieALigneFermee()) pas = (abscisseMaxi-abscisseMini)/nombrePointsPourAnimation;
    else pas = (abscisseMaxi-abscisseMini)/(nombrePointsPourAnimation - 1);
    abscisse = abscisseMini - pas;
    timeDebut = System.currentTimeMillis();
    // Si l'animation doit durer un seul cycle, on leurerra paint() en
    // mettant timeFin  timeDebut quand la boucle sera finie
    if (unSeulCycle) timeFin = timeDebut + 100000000;
    else {
      if (dureeAnimation != 0)
        timeFin = timeDebut + dureeAnimation*100; // La dure est en diximes de secondes
    }
    effacementTraces = false;
  }

  // La fonction suivanet a t amliore pour la version 1.9.5 pour ne pas sauter de traces
  // aux valeurs limites
  @Override
  public void executePourTimer(AppletMathGraph32 applet, boolean repaint) {
    double d;
    if (!executionEnCours) return;
    if (unSeulCycle)
    {
      // On leurre paint() dans l'applet en changeant le temps de dbut d'affichage 
      // si la boucle est termine
      abscisse = abscisse + pas;
      d = abscisse - abscisseMaxi;
      // if (abscisse > abscisseMaxi) {
      if ((d>0) && !Kernel.zero(d)) {
        timeFin = timeDebut;
        // C'est  dans paint() que sera appel termineAction qui arrtera l'animation
        applet.paneFigure.repaint();
        return;
      }
    }
    else
    {
      abscisse = abscisse + pas;
      if (animationCyclique)
      {
        d = abscisse - abscisseMaxi;
        // if (abscisse > abscisseMaxi) {
        if ((d>0) && !Kernel.zero(d)) {
          abscisse = abscisseMini;
          if (effacementFinCycle) effacementTraces = true;
        }
      }
      else {
        d = abscisse - abscisseMaxi;
        // if (abscisse > abscisseMaxi) {
        if ((d>0) && !Kernel.zero(d)) {
          pas = -pas;
          abscisse = abscisseMaxi;
          if (effacementFinCycle) effacementTraces = true;
        }
        else {
          d = abscisse - abscisseMini;
          // if (abscisse <= abscisseMini) {
          if ((d < 0) &&!Kernel.zero(d)) {
           pas = - pas;
           abscisse = abscisseMini;
           if (effacementFinCycle) effacementTraces = true;
          }
        }
      }
    }
    if (effacementTraces) {
      applet.initilizetbuffer();   
      effacementTraces = false;
    }
    // On dplace le point li vers sa nouvelle position
    pointLieAssocie.donneAbscisse(abscisse);
    listeDep.positionne(applet.infRand, applet.dimf);
    // Les objets devant laisser une trace le font dans le buffer de traces.
    CMathGrafDoc doc= applet.document;    
    listeAssociee.afficheToutMemeMasquesPourTrace(applet.paneFigure.tbuffer, applet.dimf, doc.couleurFond, doc.transparencePourSurfaces);    
    if (repaint) applet.paneFigure.repaint();
  }   
  
  @Override
  public void actionDansPaint(AppletMathGraph32 applet) {
    // Les objets devant laisser une trace le font dans le buffer de traces.
    // listeAssociee.afficheToutMemeMasques(applet.tbuffer, dimfen);
    // On transfere le buffer de traces dans le buffer mmoire (gbuffer)
    applet.paneFigure.transferetbufferversgbuffer();
    //listeDep.effaceTout(applet.gbuffer, dimfen);
    // On raffiche la figure complte
    applet.paneFigure.afficheToutDansgbufferSansImFond();
  }

  @Override
  public boolean executionPossible() {
    return pointLieAssocie.existe && listeAssociee.existeAuMoinsUnElement();
  }

  @Override
  public void termineAction(AppletMathGraph32 applet) {
  	MtgPaneFigure paneFigure = applet.paneFigure;
    super.termineAction(applet);
    boolean infr = applet.infRand;
    DimensionFenetre dimfen = applet.dimf;
    pointLieAssocie.donneAbscisse(abscisseInitiale);
    listeDep.positionne(infr, dimfen);
    paneFigure.transferetbufferversgbuffer();
    paneFigure.afficheToutDansgbufferSansImFond();
    // TermineAction n'est pas appel dans Paint()
    // mais dans MousePressed. Impossible de lancer un rapint() pour ne pas
    // perdre les traces. Il faut donc transfrer le gbuffer directement
    // sur le DeviceContext de l'applet.
    applet.repaint();
  }
  
 	/**
 	 * Fonction renvoyant true si l'objet dpend des positions gnres pas les dplacements d'un point li
 	 * A redfinir pour les lieux de points et lieux d'objets et macros utilisant les dplacements d'un point li
 	 * @param pointlie
 	 * @return
 	 */
   @Override
 	public boolean estGenereParPointLie(CPointLie pointlie) {
 		return pointLieAssocie == pointlie;
 	}
   
  
  @Override
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
		unSeulCycle = inps.readBoolean();
		effacementFinCycle = inps.readBoolean();
		animationCyclique = inps.readBoolean();
		frequenceAnimationMacro = inps.readCInt();
    // Frquence  vitesse maxi remplace par 1/1000 de seconde
    if (frequenceAnimationMacro == 0) frequenceAnimationMacro = 1;
		nombrePointsPourAnimation = inps.readCInt();
		dureeAnimation = inps.readCInt();
    int ind1 = inps.readCInt();
    pointLieAssocie = (CPointLie) (list.get(ind1,CPointLie.class));
    listeDep = new CListeObjets(list.uniteAngle, list.pointeurLongueurUnite);
    // Pour arrter la macro quand elle n'effectue qu'un seul cycle
    // il ne faut pas que durreAnimation soit nul;
    if (unSeulCycle) dureeAnimation = 1;
    if (list.getClass() != CPrototype.class) {
    	listeDep = new CListeObjets(listeProprietaire);
    }
  }

  /* Lecture depuis dans un flux java */  
  @Override
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
		unSeulCycle = inps.readBoolean();
		effacementFinCycle = inps.readBoolean();
		animationCyclique = inps.readBoolean();
		frequenceAnimationMacro = inps.readInt();
    // Frquence  vitesse maxi remplace par 1/1000 de seconde
    if (frequenceAnimationMacro == 0) frequenceAnimationMacro = 1;
		nombrePointsPourAnimation = inps.readInt();
		dureeAnimation = inps.readInt();
    int ind1 = inps.readInt();
    pointLieAssocie = (CPointLie) (list.get(ind1,CPointLie.class));
    listeDep = new CListeObjets(list.uniteAngle, list.pointeurLongueurUnite);
    // Pour arrter la macro quand elle n'effectue qu'un seul cycle
    // il ne faut pas que dureeAnimation soit nul;
    if (unSeulCycle) dureeAnimation = 1;
    if (list.getClass() != CPrototype.class) {
    	listeDep = new CListeObjets(listeProprietaire);
    }
  }  
  /* Enregistrement dans un flux java */
  @Override
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    oups.writeBoolean(unSeulCycle);
    oups.writeBoolean(effacementFinCycle);
    oups.writeBoolean(animationCyclique);
    oups.writeInt(frequenceAnimationMacro);
    oups.writeInt(nombrePointsPourAnimation);
    oups.writeInt(dureeAnimation);
    int ind1 = list.indexOf(pointLieAssocie);
    oups.writeInt(ind1);
  }
}
