/*
 * CNoeudPointeurSurPoint.java
 *
 * Created on 16 juillet 2004, 10:08
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

// Classe CNoeudPointeurSurPoint qui sert  construire des polygones.
// Ces noeuds contiendront des pointeurs sur les sommets du polygone
// et seront enregistrs dans une CObList contenue dans l'objet polygone}
import java.io.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CNoeudPointeurSurPoint extends CObjetBase {
  public CPointAncetre pointeurSurPoint;

  /** Creates new CNoeudPointeurSurPoint */
  public CNoeudPointeurSurPoint() {
  }
  
  public CNoeudPointeurSurPoint(CListeObjets liste, CPointAncetre pointeurSurPointInit) {
    super(liste);
    pointeurSurPoint = pointeurSurPointInit;
  }

  CNoeudPointeurSurPoint getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointeurSurPoint);
    return new CNoeudPointeurSurPoint(listeCible, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)));  
  }
      
  public void remplacePoint(CPointAncetre ancienPoint, CPointAncetre nouveauPoint) {
    if (pointeurSurPoint == ancienPoint) pointeurSurPoint = nouveauPoint;
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    pointeurSurPoint = (CPointAncetre) (list.get(ind1,CPointAncetre.class));  
  }
  
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    pointeurSurPoint = (CPointAncetre) (list.get(ind1,CPointAncetre.class));  
  }  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(pointeurSurPoint);
    oups.writeInt(ind1);
  }   
}
