/*
 * CPolygone.java
 *
 * Created on 16 juillet 2004, 10:46
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.Color;
import java.util.ListIterator;
import java.util.Vector;

import types.NatureObjet;

public class CPolygone extends CLignePolygonaleAncetre {

  /** Creates new CPolygone */
  public CPolygone() {
  	super();
  }
  
  public CPolygone(CListeObjets liste, Color couleurInit, int styleInit) {
  	super(liste, couleurInit, styleInit);
  }

  /** Constructeur pour clonage */
  public CPolygone(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit, Vector<CNoeudPointeurSurPoint> collectionPointsInit) {
    super (liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit, collectionPointsInit);
  }
  
  /** Construction  parir d'un vecteur de CNouedPointeurSurPoint */
  public CPolygone(CListeObjets liste, Vector<CNoeudPointeurSurPoint> vecteur, Color couleurInit, int styleInit) {
  	super(liste, vecteur, couleurInit, styleInit);
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    Vector<CNoeudPointeurSurPoint> colClone = new Vector<CNoeudPointeurSurPoint>();
    ListIterator<CNoeudPointeurSurPoint> li = collectionPoints.listIterator();
    while(li.hasNext()) {
      CNoeudPointeurSurPoint noeud = li.next();
      CNoeudPointeurSurPoint noeudClone = noeud.getClone(listeSource, listeCible);
      colClone.add(noeudClone);
    }
    int ind1 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CPolygone(listeCible, (CImplementationProto)(listeCible.get(ind1, CImplementationProto.class)),
      estElementFinal, couleur, masque, style, colClone);
    return ptelb;    
  }

  @Override
  public boolean confonduAvec(CElementBase p) {
    CPolygone pt;
  	CPointAncetre ptp1;
  	CPointAncetre ptp2;
  	int i,j;
  	boolean resultat;
  	
		if (p.getClass() == this.getClass()) {
		  pt = (CPolygone) p;
			int nombrePoints = collectionPoints.size();
			if (nombrePoints != pt.collectionPoints.size()) return false;
			// On regarde si un polynme a dj t cr avec les mmes sommets 
			// dans le	mme ordre. On ne regarde pas le dernier sommet qui
			// est le mme que le premier}
			nombrePoints--;
			j = 0;
			do
			{
				ptp1 = collectionPoints.get(0).pointeurSurPoint;
				ptp2 = pt.collectionPoints.get(j % nombrePoints).pointeurSurPoint;
				resultat = (ptp1 == ptp2);
				i = 1;
				while (resultat && (i <= nombrePoints-1))
				{
					ptp1 = collectionPoints.get(i).pointeurSurPoint;
					ptp2 = pt.collectionPoints.get((i+j) % nombrePoints).pointeurSurPoint;
					resultat = resultat && (ptp1 == ptp2);
					i++;
				};
				j++;
			}
			while ((j != nombrePoints) && !resultat);
			
			if (resultat) return true;
			// On regarde en tournant dans l'autre sens
			j = 0;
			do
			{
				ptp1 = collectionPoints.get(nombrePoints-1).pointeurSurPoint;
				ptp2 = pt.collectionPoints.get(j % nombrePoints).pointeurSurPoint;
				resultat = (ptp1 == ptp2);
				i = 1;
				while (resultat && (i <= nombrePoints-1))
				{
					ptp1 = collectionPoints.get(nombrePoints-1-i).pointeurSurPoint;
					ptp2 = pt.collectionPoints.get((i+j) % nombrePoints).pointeurSurPoint;
					resultat = resultat && (ptp1 == ptp2);
					i++;
				};
				j++;
			}
			while ((j != nombrePoints) && !resultat);
			return resultat;		  
		}
    else return false;
  }  
  
  public double abscisseMaximale() {
    return 1-1e-12;
  }

  public double abscisseMinimale() {
    return 0;
  }

  @Override
  public long getNature() {
    return NatureObjet.NPolygone;
  }

  @Override
  public String complementInfo() {
    return textes.Chaines.chinfo45;
  }
  
  // Rajout pour la version 1.9.5
	boolean lieALigneFermee() {
    return true;
  }
	
  public String nomSommetsPolygone() {
  	int lon = 0;
  	for (int i=0; i < collectionPoints.size() - 1; i++) {
      CNoeudPointeurSurPoint noeud = collectionPoints.get(i);
      CPointAncetre ptp = noeud.pointeurSurPoint;
      lon += ptp.nom.length();
    }
  	StringBuffer stb = new StringBuffer(lon);
  	for (int i=0; i < collectionPoints.size() - 1; i++) {
      CNoeudPointeurSurPoint noeud = collectionPoints.get(i);
	    CPointAncetre ptp = noeud.pointeurSurPoint;
	    stb.append(ptp.nom);
    }
    return stb.toString();
  }
	
}
