/*
 * CResultatValeur.java
 *
 * Created on 1 juillet 2004, 17:40
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public class CResultatValeur extends CCalculBase {
  // La valeur associe
	public CValeurDynamique valeurAssociee;

  /** Creates new CResultatValeur */
  public CResultatValeur() {
  }
  
  // Constructeur avec une valeur initiale
  public CResultatValeur(CListeObjets liste, CValeurDynamique valeurInit)
  {
    super(liste);
    valeurAssociee = valeurInit;
  }
  
  public CCalculBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(valeurAssociee);    
    CCalculBase ptcalc = new CResultatValeur(listeCible, (CValeurDynamique)(listeCible.get(ind1, CValeurDynamique.class)));
    return ptcalc;  
  }
  
  public boolean existe() {
  	return valeurAssociee.existe;
  }
  
  public double resultat(boolean infoRandom) {
    return valeurAssociee.rendValeur(infoRandom);
  }
  
  public boolean dependDe(CElementBase p) {
  	return valeurAssociee.dependDe(p);
  }
  
  public boolean dependDePourBoucle(CElementBase p) {
  	return valeurAssociee.dependDePourBoucle(p);
  }
  
  public boolean  dependDeVariable() {
    return false;
  }
  public CCalculBase getCopie() {
  	return new CResultatValeur(listeProprietaire, valeurAssociee);
  } 
  
  @Override
	public String chaineCalcul(String varFor) {
		return valeurAssociee.nom();
	}
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    valeurAssociee = (CValeurDynamique) (list.get(ind1,CValeurDynamique.class));
  }
  
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    valeurAssociee = (CValeurDynamique) (list.get(ind1,CValeurDynamique.class));
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(valeurAssociee);
    oups.writeInt(ind1);
  }
  
  // L'appel  une valeur dynamique est forcment non constant
  @Override
	public boolean estConstant() {
		return valeurAssociee.getClass() == CCalcConst.class;
	}
  
}
