/*
 * CSurface.java
 *
 * Created on 18 juillet 2004, 10:09
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;
// Classe anctre de toutes les classes de surface possdant un bord
import java.io.*;
import java.awt.Color;

import types.*;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

public abstract class CSurface extends CSurfaceAncetre {
	CElementGraphique bord;	// Le bord qui sera du type cercle,

  /** Creates new CSurface */
  public CSurface() {
  }
  
  // Constructeur pour clonage
  public CSurface(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleRemplissageInit, CElementGraphique bordInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleRemplissageInit);
    bord = bordInit;
  }
  
  @Override
  public boolean confonduAvec(CElementBase p) {
  	boolean res = super.confonduAvec(p);
  	if (!res) return false;
  	CSurface pt = (CSurface) p;
  	res = res && (bord == pt.bord);
  	return res;
  }
  
  public boolean dependDe(CElementBase p) {
    return super.dependDe(p) || bord.dependDe(p);
  }

  public boolean dependDePourBoucle(CElementBase p) {
    return ((p == this) || bord.dependDePourBoucle(p));
  }

  public boolean dependDePourCapture(CElementBase p) {
    return ((p == this) || bord.dependDePourCapture(p));
  }

  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = bord.existe;
  }
  
  @Override
  public double distancePoint(double xp, double yp, boolean masquage) {
  	if (!existe || (masquage && masque)) return -1;
  	return bord.distancePoint(xp, yp, masquage);
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    bord = (CElementGraphique) (list.get(ind1,CElementGraphique.class));
  }

  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    bord = (CElementGraphique) (list.get(ind1,CElementGraphique.class));
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(bord);
    oups.writeInt(ind1);
  } 
}
