/*
 * CSurfaceLieu.java
 *
 * Created on 18 juillet 2004, 18:45
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.*;
import java.io.*;
import types.*;
import entreesSorties.MathGraphDataInputStream;

public class CSurfaceLieu extends CSurface {
  // Il faut deux tableaux pour y transfrer les coordonnes des points
  int[] abscisses;
  int[] ordonnees;
  // Pour le trac
  private int nbPointsLigne;  
  /** Creates new CSurfaceLieu */
  public CSurfaceLieu() {
  }

  // Constructeur pour clonage
   public CSurfaceLieu(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
     Color couleurInit, boolean masqueInit, int styleRemplissageInit, CLieuDeBase bordInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleRemplissageInit, bordInit);
    metAJourTableaux();
   }

   @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(bord);
    int ind2 = listeSource.indexOf(impProto);        
    return new CSurfaceLieu(listeCible, (CImplementationProto)listeCible.get(ind2, CImplementationProto.class),
      estElementFinal, couleur, masque, styleRemplissage, (CLieuDeBase)listeCible.get(ind1, CLieuDeBase.class));
  }
  
  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    if (ptel.existe) {
	    nbPointsLigne = ((CSurfaceLieu)ptel).nbPointsLigne;
	    System.arraycopy(((CSurfaceLieu)ptel).abscisses, 0, abscisses, 0, nbPointsLigne);
	    System.arraycopy(((CSurfaceLieu)ptel).ordonnees, 0, ordonnees, 0, nbPointsLigne);
    }
  }
  
  /**
   * Fonction appele quand on change le nombre de points du lieu qui est le bord de la surface
   */
  @Override
  public void metAJourTableaux() {
    abscisses = new int[((CLieuDeBase)bord).infoLieu.nombreDePoints + 1];
    ordonnees = new int[((CLieuDeBase)bord).infoLieu.nombreDePoints + 1];  	
  }
      
  @Override
  public boolean aPourBord(CLieuDeBase lieu) {
  	return (lieu == bord);
  }  
  

  @Override
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    CLieuDeBase lieu;
    lieu = (CLieuDeBase) bord;

    super.positionne(infoRandom, dimfen);
    existe = existe && lieu.contientUneSeuleLigne();
    if (existe) {
      int indicePremiereLigneLieu = lieu.indicePremiereLigne;
      int indicePremierPointLigne = lieu.infoLignes[indicePremiereLigneLieu].indicePremierPoint;
      nbPointsLigne = lieu.infoLignes[indicePremiereLigneLieu].nombrePoints;
      System.arraycopy(lieu.abscissesCoordonneesPoints, indicePremierPointLigne,
        abscisses, 0, nbPointsLigne);
      System.arraycopy(lieu.ordonneesCoordonneesPoints, indicePremierPointLigne,
        ordonnees, 0, nbPointsLigne);
    }
  }

  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
    int styleRemplissageEffectif;
    if (masque) styleRemplissageEffectif = StyleRemplissage.QuadrillageCroise;
    else styleRemplissageEffectif = styleRemplissage;
    if (styleRemplissageEffectif == StyleRemplissage.QuadrillagePleinTransp) {
    	if (transparence != 1) {
    		pDC.setColor(couleur);
  	    Composite originalComposite = pDC.getComposite();
  	    pDC.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, transparence));
  	    pDC.fillPolygon(abscisses, ordonnees, nbPointsLigne);
  	    pDC.setComposite(originalComposite);    		
    	}
    	else {
    		pDC.setColor(couleur);
    		pDC.fillPolygon(abscisses, ordonnees, nbPointsLigne);
    	}
    }
    else {
      if (styleRemplissageEffectif == StyleRemplissage.QuadrillagePlein) {
    		pDC.setColor(couleur);
    		pDC.fillPolygon(abscisses, ordonnees, nbPointsLigne);
      }
      else {
	    	TexturePaint tp = StyleRemplissage.getTexturePaint(couleur, styleRemplissageEffectif, listeProprietaire.basseDefinition, couleurFond);
	    	pDC.setPaint(tp);
	    	pDC.fillPolygon(abscisses, ordonnees, nbPointsLigne);
      }
    } 
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    // Modification pour la version 2.5.
    // Certaines choses pas  faire pour le chargement d'un prototype
    if (list.getClass() != CPrototype.class) {
      abscisses = new int[((CLieuDeBase)bord).infoLieu.nombreDePoints + 1];
      ordonnees = new int[((CLieuDeBase)bord).infoLieu.nombreDePoints + 1];
    }
  }
  
  /* Lecture depuis un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
  	super.read(inps, list);
    if (list.getClass() != CPrototype.class) {
      abscisses = new int[((CLieuDeBase)bord).infoLieu.nombreDePoints + 1];
      ordonnees = new int[((CLieuDeBase)bord).infoLieu.nombreDePoints + 1];
    }
  }
  
}
