/*
 * CSurfacePolygone.java
 *
 * Created on 18 juillet 2004, 10:16
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

// Surface dlimite par un polygone
import java.awt.*;

import types.*;

public class CSurfacePolygone extends CSurface {

  /** Creates new CSurfacePolygone */
  public CSurfacePolygone() {
  }
  
  // Constructeur pour clonage
  public CSurfacePolygone(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, boolean masqueInit, int styleRemplissageInit, CPolygone bordInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleRemplissageInit, bordInit);
  }

  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(bord);
    int ind2 = listeSource.indexOf(impProto);        
    CElementBase ptelb = new CSurfacePolygone(listeCible, (CImplementationProto)listeCible.get(ind2, CImplementationProto.class),
      estElementFinal, couleur, masque, styleRemplissage, (CPolygone)listeCible.get(ind1, CPolygone.class));
    return ptelb;    
  }
    
  @Override  
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {

    int styleRemplissageEffectif;
    if (masque) styleRemplissageEffectif = StyleRemplissage.QuadrillageCroise;
    else styleRemplissageEffectif = styleRemplissage;
    if (styleRemplissageEffectif == StyleRemplissage.QuadrillagePleinTransp) {
    	if (transparence != 1) {
    		pDC.setColor(couleur);
  	    Composite originalComposite = pDC.getComposite();
  	    pDC.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, transparence));
  	    pDC.fillPolygon(((CPolygone)bord).abscissesCoordonneesPoints, ((CPolygone)bord).ordonneesCoordonneesPoints, 
  	        ((CPolygone)bord).collectionPoints.size());
  	    pDC.setComposite(originalComposite);    		
    	}
    	else {
    		pDC.setColor(couleur);
    		pDC.fillPolygon(((CPolygone)bord).abscissesCoordonneesPoints, ((CPolygone)bord).ordonneesCoordonneesPoints, 
    	      ((CPolygone)bord).collectionPoints.size());
    	}
    }
    else {
      if (styleRemplissageEffectif == StyleRemplissage.QuadrillagePlein) {
    		pDC.setColor(couleur);
    		pDC.fillPolygon(((CPolygone)bord).abscissesCoordonneesPoints, ((CPolygone)bord).ordonneesCoordonneesPoints, 
    	      ((CPolygone)bord).collectionPoints.size());
      }
      else {
	    	TexturePaint tp = StyleRemplissage.getTexturePaint(couleur, styleRemplissageEffectif, listeProprietaire.basseDefinition, couleurFond);
	    	pDC.setPaint(tp);
	    	pDC.fillPolygon(((CPolygone)bord).abscissesCoordonneesPoints, ((CPolygone)bord).ordonneesCoordonneesPoints, 
	          ((CPolygone)bord).collectionPoints.size());
      }
    }
  }

}
