/*
 * CSurfaceRemplie.java
 *
 * Created on 18 juillet 2004, 19:41
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.Color;
import java.awt.Graphics2D;
import java.io.IOException;

import types.DimensionFenetre;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;


public class CSurfaceRemplie extends CSurfaceAncetre {
	CPointAncetre pointInterieur;
	CSousListeObjets listeBord;

  /** Creates new CSurfaceRemplie */
  public CSurfaceRemplie() {
    listeBord = new CSousListeObjets();
  }
  
  // Constructeur pour clonage
   public CSurfaceRemplie(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
        Color couleurInit, boolean masqueInit, int styleRemplissageInit,
        CPointAncetre pointInterieurInit, CSousListeObjets listeBordInit) {
     super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleRemplissageInit);
     pointInterieur = pointInterieurInit;
     listeBord = listeBordInit;     
   }  
  
   @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointInterieur);
    int ind2 = listeSource.indexOf(impProto);        
    listeBord = new CSousListeObjets();
    CElementBase ptelb = new CSurfaceRemplie(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, masque, styleRemplissage, (CPointAncetre)(listeCible.get(ind1, CPointAncetre.class)), listeBord);
    listeBord.setImage(((CSurfaceRemplie)ptelb).listeBord, listeProprietaire, ptelb.listeProprietaire);
    return ptelb;
  }
  
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    existe = false; // classe non implmente en java
  }
  
  @Override
  public void trace(Graphics2D pDC, Color couleurFond, float transparence) {
  }
  
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets list) throws IOException {
    super.chargeDepuisFlux(inps, list);
    int ind1 = inps.readCInt();
    pointInterieur = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    listeBord.chargeDepuisFlux(inps, listeProprietaire);
  }
  
  /* Lecture depuis dans un flux java */  
  public void read(MathGraphDataInputStream inps, CListeObjets list)  throws IOException {
    super.read(inps, list);
    int ind1 = inps.readInt();
    pointInterieur = (CPointAncetre) (list.get(ind1,CPointAncetre.class));
    listeBord.read(inps, listeProprietaire);
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets list)  throws IOException {
    super.write(oups, list);
    int ind1 = list.indexOf(pointInterieur);
    oups.writeInt(ind1);
    listeBord.write(oups, list);
  }    
}
