/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import Applet.AppletMathGraph32;
import Applet.GestionnaireEdition;
import java.awt.Toolkit;
import java.io.IOException;

/**
 *
 * @author Yves
 */
public class OutilAnnuler extends Outil {
  public OutilAnnuler(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, false, AppletMathGraph32.iconAnnuler);
  }
  
  public String chaineInfo() {
    GestionnaireEdition gest = appletMere.gestionnaire;
    if (gest.annulationPossible()) return getString("ch13") + appletMere.gestionnaire.chaineNatureAnnulationEnCours();
    else return "";
  }

  public String toolTip() {
    return getString("toolTip1");
  }
  
  public void select() {
    super.select();
    try {
      if (appletMere.gestionnaire.annulationPossible()) {
        appletMere.gestionnaire.annuleAction();
      }
      else Toolkit.getDefaultToolkit().beep();
    }
    catch (IOException err) {}
    appletMere.activeOutilCapture();
  }
}
