/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;
import Applet.*;
import java.awt.*;
import objets.*;
import types.*;

/**
 *
 * @author Yves
 */
public class OutilSup extends Outil {
  private CElementGraphique objet;
  private CElementBase elementEffectifASupprimer;
  
  /** Creates a new instance of OutilSup */
  public OutilSup(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, true, AppletMathGraph32.iconSupprimerObjetGraphique);
  }
    
  public String toolTip() {
    return getString("toolTip20");
  }
  
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    objet = null;
    appletMere.outilPointageActif = appletMere.outilPointageSup;
    designationDe(NatureObjet.NToutObjet);
    appletMere.indication(getString("suppression1"));
  }
    
  	// Modifi version 3.3.3.1
    @Override
    public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
      if (objet == null) {
      	CListeObjets liste = appletMere.listePr;
        objet = elg;
        elementEffectifASupprimer = elg.antecedentDirect();
        ajouteClignotementDe(elg);
        resetClignotement();
        if (elementEffectifASupprimer.getNature() == NatureObjet.NTransformation) {
        	// Si l'objet antcdent direct est une transformation, on regarde s'il y a d'autres images par
        	// cette transformation  dtruire. Si oui, on ne dtruit pas la transformation.
        	// Sinon on dtruit la transformation et ses dpendants.
        	if (liste.nombreImagesParTransformationNonDepDe((CTransformation) elementEffectifASupprimer, elg) > 0) elementEffectifASupprimer = elg;
        } 
        if (elementEffectifASupprimer.getNature() == NatureObjet.NBipoint)  {
        	CBipoint bip = (CBipoint) elementEffectifASupprimer;
        	CPointLieBipoint ptlb1 = bip.pointReelDansListe(1);
        	if (ptlb1 != elg) ajouteClignotementDe(ptlb1);
        	CPointLieBipoint ptlb2 = bip.pointReelDansListe(2);
        	if (ptlb2 != elg) ajouteClignotementDe(ptlb2);
          if (!appletMere.dialogueConfirmation_YES_NO(getString("ch38"))) {
          	select();
          	return;
          }
          if (liste.nombreDependants(elementEffectifASupprimer) >= 3) {
            ajouteClignotementDe(elg);
            resetClignotement();
            if (!appletMere.dialogueConfirmation_YES_NO(getString("ch37"))) {
              select();
              return;
            }
           }
          creeObjet();        
        }
        else {
  	      if (liste.nombreDependants(elg) >= 2) {
  	        ajouteClignotementDe(elg);
  	        resetClignotement();
  	        if (!appletMere.dialogueConfirmation_YES_NO(getString("ch37"))) {
  	          select();
  	          return;
  	        }
  	       }
  	     creeObjet();
        }
      }
    }  
  /** Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns. Ici on dtruit l'objet dsign.
   *Amlioration par rapport au C++, l'ordre de destruction se fait sur l'antcdent
   * direct c'est  dire le premier des objts crs pour crer l'objet supprim
   *qui est lui-mme suaf pour les images et les intersections de cercles avec cerlces
   * ou droites.
   */
  public void creeObjet() {
    appletMere.retireDependants(objet.antecedentDirect());
    appletMere.etablitListeObjetsConstruits();
    appletMere.gestionnaire.enregistreFigureEnCours(getString("chaineOutil16"));
    appletMere.redessine();
    select();
  }
 
	@Override
  public Cursor curseurUtilise() {
		return AppletMathGraph32.supCursor;
	}
  
}
