/*
 * OutilTranslation.java
 *
 * Created on 7 juin 2006, 10:58
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package outils;

import java.awt.*;
import objets.*;
import types.*;
import Applet.*;

/**
 *
 * @author Yves
 */
public class OutilTranslation extends Outil {
  CPointAncetre point1;
  CPointAncetre point2;
  CElementGraphique objet;
  
  /** Creates a new instance of OutilTranslation */
  public OutilTranslation(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, true);
  }

  public int idMenu() {
    return 32845;
  }
  
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "Translation.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo23;
  }  

  public String toolTip() {
    return textes.Chaines.toolTip23;
  }
  
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    point1 = null;
    point2 = null;
    objet = null;
    designationDe(NatureObjet.NToutPoint);
    appletMere.indication(textes.Chaines.translation1);
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CListeObjets liste = appletMere.listePr;
    CTranslation ptTrans = new CTranslation(liste, null, false, point1, point2);
    appletMere.ajouteElement(ptTrans);
    CElementGraphique elg = imageParTransformation(liste,  objet, ptTrans);
    if (appletMere.ajouteElementAvecVerification(elg)) {
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil19);
    }
    else {
      appletMere.detruitDernierElement();
    }
    annuleClignotement();
    appletMere.activeOutilCapture();
  }
  
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets liste = appletMere.listeObjetsVisuels;
    CTranslation trans = new CTranslation(liste, null, false, point1, point2);
    appletMere.ajouteObjetVisuel(trans);
    CPointImage ptim = new CPointImage(liste, null, false, Couleur.TraduitCouleur(1),
       MotifPoint.petitRond, 2, appletMere.pointSouris, trans);
    appletMere.ajouteObjetVisuel(ptim);
    CVecteur vec = new CVecteur(appletMere.listeObjetsVisuels, null, false,
      Couleur.TraduitCouleur(1), false, StyleTrait.traitPointille,
      appletMere.pointSouris, ptim, StyleFleche.FlecheCourtePleine);
    appletMere.ajouteObjetVisuel(vec);
  }

  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (point1 == null) {
      appletMere.indication(textes.Chaines.translation2);
      point1 = (CPointAncetre) elg;
      excluDeDesignation(elg);
      ajouteClignotementDe(elg);
      resetClignotement();
    }
    else {
      if (point2 == null) {
        appletMere.indication(textes.Chaines.translation3);
        point2 = (CPointAncetre) elg;
        CVecteur vecteurClignotant = new CVecteur(appletMere.listePr, null, false,
            Couleur.TraduitCouleur(2), false, StyleTrait.traitEpais, null, null,
            StyleFleche.FlecheCourtePleine);
          vecteurClignotant.donneExtremites(point1, point2);
          vecteurClignotant.positionne(false, appletMere.dimf);
        ajouteObjetsVisuels();
        ajouteClignotementDe(elg);
        ajouteClignotementDe(vecteurClignotant);
        // Spcial applet : on ne pourra pas crer d'image de segments, polygones
        designationDe(appletMere.natureObjetsPourImages());
      }
      else {
        if (objet == null) {
          objet = elg;
          creeObjet();
          annuleClignotement();
        }
      }
    }
  }  
  
}
